
Handle_Ability()
{
	if(g_iGameMode != GAME_INPLAY)
		return;
		
	new ballTeam = GetBallData( BALL_TEAM );
	new oTeam = ballTeam == 1 ? 2 : 1;
		
	if( ShouldGiveBonus() )
		Ability_GiveTeamAgi( oTeam, TEAM_AGI_BONUS );
	else
		Ability_GiveTeamAgi( oTeam, 0.0 );	
}

Ability_Spawn(id)
{
	cs_set_user_armor(id, floatround(BASE_STAMINA), CS_ARMOR_KEVLAR)
	
 	if( g_bPlayClockOn )
 		g_flStamina[id] = BASE_STAMINA;
 		
 	new class = GetClass(id);
 	new hp = floatround(BASE_HEALTH);
 	if(class > CLASS_LINEMAN)
 		class = 0;
 		
 	//new bonushp = floatround(float(hp) * g_flAbilityStats[class][_STR]);
 	
 	//if(bonushp > 100)
 	//	hp += bonushp - 100;
 	Ability_Remove( id, A_DIVE );
 	Ability_Remove( id, A_TURBO_QUICK );
 	
 	set_user_health( id, 256 + hp );	
 	entity_set_float(id, EV_FL_maxspeed, BASE_SPEED)	
}

bool:Ability_IsActive( id, ability )
{
	return ((g_iAbility[id] & (1<<ability)) > 0);
}

Ability_Set( id, ability )
{
	g_iAbility[id] |= (1<<ability);	
}

Ability_Remove( id, ability )
{
	g_iAbility[id] &= ~(1<<ability);	
}
	
Float:Ability_GetDelay( id, ability )
{
	return g_flAbilityDelay[id][ability];	
}

Ability_SetDelay( id, ability, Float:delay )
{
	g_flAbilityDelay[id][ability] = delay;	
}
	
Float:Ability_Price( id, ability )
{
	if(g_iGameMode != GAME_INPLAY) //FREE ABILITY!!!
		return 0.0;	

	//new Float:stamina = g_flStamina[id];
	new Float:price = g_flAbilityPrice[ability];

	if(ability == A_JUMP)
	{
		new class = GetClass(id);
		if(class == CLASS_SAFETY)	
		{
			price = PRICE_SAFETY_JUMP;	
		}
	}
	else if(ability == A_TURBO_QUICK)
	{
		new class = GetClass(id);
		if(class == CLASS_SAFETY)
		{
			price = PRICE_SAFETY_TURBO;	
		}	
		else if(class == CLASS_RUNNINGBACK && GetBallData(BALL_HOLDER) == id)
		{
			price = PRICE_RB_HOLDER_TURBO;	
		}
	}
	else if(ability == A_STIFFARM)
	{
		new holder = GetBallData( BALL_HOLDER );
		if(holder == id)
		{
			price = PRICE_STIFFARM_BALLHOLDER;	
		}	
	}
	
	return price;
}

bool:Ability_Activate( id, ability )
{
	if( Ability_CanUse( id, ability ) )
	{
		//new Float:defaultPrice = g_flAbilityPrice[ability];
		new Float:price  = Ability_Price( id, ability );
		
		if(g_flStamina[id] >= price)
		{
			g_flStamina[id] -= price;
			Ability_Set( id, ability );
			//flPriceDiff = boughtPrice/defaultPrice;
			return true;
		}
	}	
	return false;
}

Ability_GiveTeamAgi( team, Float:amount )
{
	g_flAbilityTeamAgi[team] = amount;
}
/*
Ability_ClearTeamAgi()
{
	g_flAbilityTeamAgi[T] = 0.0;
	g_flAbilityTeamAgi[CT] = 0.0;
}
*/
Float:Ability_Strength( id, ability )
{
	//new startTeam = GetBallData(BALL_START_TEAM);
	//new ballTeam = GetBallData(BALL_TEAM);
	new holder = GetBallData(BALL_HOLDER);
	new class = GetClass(id);
	new team = get_user_team(id);
	new statType; //_STR by default.
	new Float:flStrength = 1.0;
	//new pclass = class;
	
	if(ability != A_THROW && id == holder && class != CLASS_QUARTERBACK)
		class = 0;
		
	switch( ability )
	{
		case A_TURBO_QUICK: 
		{
			statType = _AGI;
			//1.50;
		}
		case A_TURBO_LONG:  statType = _AGI;
		case A_OLDDIVE:
		{
			statType = _AGI;
			flStrength = 1.0;	
		}
		case A_DIVE:
		{
			statType = _AGI;
			//if(class == CLASS_SAFETY)
			//	flStrength = 1.5;
		}
		case A_JUMP:
		{
			statType = _AGI;
			
			if(class == CLASS_QUARTERBACK)
				flStrength = 1.2;
			else if(GetClass(id) == CLASS_RUNNINGBACK && id==holder)
				flStrength = 1.02;
			else
				flStrength = 0.95;
		}
		case A_QUICKTACKLE: statType = _STR;
		case A_STIFFARM:	statType = _STR;
		case A_THROW:		statType = _DEX;
		case A_TACKLED:		statType = _STR;
	}

	
	flStrength *= g_flAbilityStats[class][statType];
	
	if(statType == _AGI && g_flAbilityTeamAgi[team] > 0.0)
		flStrength += g_flAbilityTeamAgi[team];
		
	return flStrength;
	
}
bool:Ability_CanUse( id, ability )
{
	//return true;
	
	new class = GetClass(id);
	if(class == 0)
		return false;
		
	new team = get_user_team(id);
	if(team != 1 && team != 2)
		return false;
		
	new startTeam = GetBallData(BALL_START_TEAM);
	//new ballTeam = GetBallData(BALL_TEAM);
	new holder = GetBallData(BALL_HOLDER);
	
	switch(ability)
	{
		case A_TURBO_QUICK, A_TURBO_LONG: 	
		{
		}
		case A_DIVE:		
		{
			if(class != CLASS_RUNNINGBACK)
				return false;
			//if(!g_bPassedScrimmage && class == CLASS_LINEMAN && team != ballTeam)
			//	return false;
		}		
		case A_JUMP:		
		{
			if(id == holder && !(class == CLASS_QUARTERBACK && !g_bPassedScrimmage))
				return false;
		
			if( g_iPlay != PLAY_KICKOFF && team != startTeam && !g_bPassedScrimmage && class != CLASS_LINEMAN )
			{
				new Float:origin[3];
				entity_get_vector(id, EV_VEC_origin, origin );
				new Float:yard = GetYard( origin[1] );
				if(yard < g_flCurrentYard )
					return false;
			}
		}		
		case A_QUICKTACKLE:	
		{
			if(id == holder)
				class = 0;
				
			if( g_flAbilityStats[class][_STR] < 0.8 )
				return false;
		}			
		case A_STIFFARM:
		{
			if((class != CLASS_LINEMAN && class != CLASS_SAFETY) && id != holder )
				return false;
			
		}		
		case A_THROW:		
		{
		}		
		case A_TACKLED:		
		{
		}		
	}	
	
	return true;
	
}

#define HIT_GENERIC		0	/* none */
#define HIT_HEAD		1
#define HIT_CHEST		2
#define HIT_STOMACH		3
#define HIT_LEFTARM		4
#define HIT_RIGHTARM		5
#define HIT_LEFTLEG		6
#define HIT_RIGHTLEG		7

/*
new g_szBodyParts[HIT_RIGHTLEG+1][] =
{
	"HIT_GENERIC",
	"HIT_HEAD",
	"HIT_CHEST",
	"HIT_STOMACH",
	"HIT_LEFTARM",
	"HIT_RIGHTARM",
	"HIT_LEFTLEG",
	"HIT_RIGHTLEG"
}
*/

Handle_Damage( attacker, victim, damage )
{
	//new class = GetDefaultClass(attacker);
	new hp = get_user_health(victim)
	
	new Float:stam = g_flStamina[attacker];
	//new stamAmt = damage;
	stam += float(damage) * 0.8;
	
	if(stam > BASE_STAMINA)
		stam = BASE_STAMINA;
		
	g_flStamina[attacker] = stam;
	cs_set_user_armor(attacker, floatround(stam), CS_ARMOR_KEVLAR);
	
	//new Float:vStart[3], Float:vEnd[3], Float:vReturn[3];
	
	//new isVictim;
	//new bodyPart;
	//new Float:dist = get_user_aiming(attacker, isVictim, bodyPart, 9999);
	
	//if( isVictim == victim )
	//{
	//	client_print( 0,print_chat,"bodyPart = %s", g_szBodyParts[bodyPart] );	
	//}
	hp = Ability_Damage( attacker, victim, damage );
	
	if(hp <= 256)
	{
		Ability_Tackle( attacker, victim );
	}	
	else
	{
		set_user_health( victim, hp );	
	}
	
	return PLUGIN_CONTINUE;
}

Ability_Tackle( attacker, victim )
{
	if(g_iGameMode != GAME_INPLAY)
		return;
	
	new holder = GetBallData( BALL_HOLDER );
	new frags;
	if(holder == victim)
	{
		frags = get_user_frags(attacker);
		entity_set_float(victim, EV_FL_frags, float(frags+2));
		FX_DeathMsg( attacker, victim, "knife" );	
	}
	else
	{
		new victimClass = GetClass(victim);
		new attackerClass = GetClass(attacker);
		if(g_iPlay == PLAY_STANDARD && !g_bPassedScrimmage)
		{
			new Float:origin[3];
			new Float:yard;
			entity_get_vector( victim, EV_VEC_origin, origin );
			yard = GetYard( origin[1] );
			if(yard >= g_flCurrentYard && !(victimClass == CLASS_LINEMAN && attackerClass == CLASS_LINEMAN))
			{
				set_user_health( victim, 256 + floatround(BASE_HEALTH) );
				return;
			}
		}	
	}
	
	set_user_health( victim, 256 + floatround(BASE_HEALTH) );
	Death_Scene(victim);
	
	frags = get_user_frags(victim);
	entity_set_float(victim, EV_FL_frags, float(frags+1))
	user_kill(victim);
	

	/*
	if(GetBallData(BALL_HOLDER) == victim)
	{
		new frags = get_user_frags(victim);
		new frags2 = get_user_frags(attacker);
		entity_set_float(victim, EV_FL_frags, float(frags+1))
			
		set_msg_block( g_msgDeathMsg, BLOCK_ONCE );
		//fakedamage( victim, "weapon_knife", 280.0, dmgtype );	
		user_kill(victim);
			
		FX_DeathMsg( attacker, victim, "knife" );
		
	
		entity_set_float(attacker, EV_FL_frags, float(frags2 + 2))
	}
	else if(CanPlayersKill())
	{
		new frags = get_user_frags(victim);
		entity_set_float(victim, EV_FL_frags, float(frags+1))
		set_msg_block( g_msgDeathMsg, BLOCK_ONCE );
		user_kill(victim);	
	}
	else
	{
		if(special == -1 && class == OFFENSE_LINEMAN )
		{
			new frags = get_user_frags(victim);
			entity_set_float(victim, EV_FL_frags, float(frags+1))
			set_msg_block( g_msgDeathMsg, BLOCK_ONCE );
			user_kill(victim);
		}
		else
			set_user_health(victim, MAX_HEALTH+256 )
		
	}	
	*/
}

Death_Scene(id)
{
	//entity_set_int( id, EV_INT_solid, SOLID_NOT );
	//entity_set_int( id, EV_INT_effects, entity_get_int( id, EV_INT_effects ) | EF_NODRAW );
	
	Ability_Set( id, A_TACKLED );
	Ability_SetDelay( id, A_TACKLED, get_gametime() + 2.0 );
	
	//Create_PlayerCamera( id );
}

Ability_Damage( attacker, victim, damage )
{
	new hp = get_user_health(victim);
	new ballholder = GetBallData( BALL_HOLDER );
	new victimClass = GetClass(victim);
	
	if( victim == ballholder )
	{
		new throwType = GetBallData( BALL_THROW_FLY );
		if( !(throwType == FLY_HANDOFF && victimClass == CLASS_RUNNINGBACK && g_iPlay == PLAY_STANDARD) )
			if( damage > 50 && Ability_Activate( attacker, A_QUICKTACKLE ) )
				return 0;
	}
	
	new Float:vel[3];
	entity_get_vector( victim, EV_VEC_velocity, vel );
	
	if( Ability_IsActive( victim, A_DIVE ) )
	{
		vel[0] *= 0.3;
		vel[1] *= 0.3;
	}
	
	new attackerClass = GetClass(attacker);
	if(attackerClass == CLASS_LINEMAN)
		hp -= floatround( float(damage) * 0.3 );
		
	if( !Ability_Activate( attacker, A_STIFFARM ) )
	{
		entity_set_vector( victim, EV_VEC_velocity, vel );
		return hp;	
	}
	
	
	
	new Float:ang[3], Float:dir[3];
	new Float:speed, Float:upVel;
	
	new Float:stat_multiplier = Ability_Strength( attacker, A_STIFFARM );
	
		
	if( damage < 50 ) 	{	speed = 300.0; upVel = 250.0; }
	else 				{	speed = 450.0; upVel = 275.0; }
					
	if( !on_ground(victim) )
		upVel = 0.0;
						
	speed *= stat_multiplier;
	upVel *= stat_multiplier;
	
	entity_get_vector( attacker, EV_VEC_v_angle, ang );
	
	
	angle_vector(ang, ANGLEVECTOR_FORWARD, dir)
	vel[0] += dir[0] * speed;
	vel[1] += dir[1] * speed;
	vel[2] += upVel;
	entity_set_vector( victim, EV_VEC_velocity, vel );
	
	return hp;
}

/*
//native bool:CanPlayersKill();
bool:CanPlayersKill()
{
	if(g_bCanKill)
		return true;
		
	new id;
	new ballholder;
	
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if(!is_user_alive(id))
			continue;
			
		if(GetBallData(BALL_HOLDER) == id)
		{
			ballholder = id;
			break;
		}
	}	
	
	if(g_iPlay == PLAY_STANDARD && IsSpecial(ballholder) != QUARTERBACK && ballholder != 0 )
		g_bCanKill = true;
		
	if(g_bPassedScrimmage)
		g_bCanKill = true;
		
	if(g_iPlay == PLAY_KICKOFF && ballholder != 0)
		g_bCanKill = true;
		
	return g_bCanKill;
}
*/

public Ability_PreThink(id)
{
	if(!is_user_connected(id))
		return FMRES_IGNORED;
		
	new class = GetClass(id);
	if(class == 0)
		return FMRES_IGNORED;
		
	new flags = entity_get_int( id, EV_INT_flags );
	if(flags & FL_FROZEN > 0)
		entity_set_int( id, EV_INT_weaponanim, 0 );
	new bool:onground = on_ground(id);
	new button = entity_get_int( id, EV_INT_button );
	new oldbutton = entity_get_int( id, EV_INT_oldbuttons );
	new bool:bDive = Ability_IsActive( id, A_DIVE );
	
	new flytype = GetBallData( BALL_FLY );
	
	//new Float:origin[3];
	//entity_get_vector(id, EV_VEC_origin, origin );
	//new Float:yard = GetYard( origin[1] );
	
	if( flytype == FLY_PASS)// || (!g_bPassedScrimmage && yard > g_flCurrentYard && class != CLASS_LINEMAN) )
	{
		BlockAttack(id, 0.25);	
	}
	
	if(!bDive && class != 0 && class <= CLASS_LINEMAN && onground)// && IsTurbo(id))
	{
		//new flytype = GetBallData(BALL_FLY);
		if((class == CLASS_RECEIVER && (!g_bPassedScrimmage) ) || (g_bPassedScrimmage && GetBallData(BALL_HOLDER) == id && class == CLASS_RUNNINGBACK && Ability_IsActive(id, A_TURBO_QUICK)))
		{
			pev(id, pev_velocity, g_vecVel[id])
			g_bRestoreVel[id] = true
		}
	}
	
	Ability_Turbo( id );
	Ability_Dive( id, button, oldbutton );
	Ability_Jump( id, button, oldbutton );

	cs_set_user_armor(id, floatround(g_flStamina[id]), CS_ARMOR_KEVLAR);
	
	return FMRES_IGNORED;
}

public Ability_PreThink_Post(id)
{
	if(g_bPlayerFrozen[id])
	{
		new Float:origin[3];
		entity_get_vector(id,EV_VEC_origin, origin );
		g_vPlayerPos[id][2] = origin[2];
		entity_set_vector(id,EV_VEC_origin, g_vPlayerPos[id] );
		return FMRES_IGNORED;
	}
	

	if(!Ability_IsActive(id, A_DIVE) && g_bRestoreVel[id])
	{
		g_bRestoreVel[id] = false;
		set_pev(id, pev_velocity, g_vecVel[id]);	
	}
	return FMRES_IGNORED;
}

Handle_AbilityCmdStart( id, &button )
{
	if(Ability_IsActive(id, A_DIVE))
		button &= ~IN_DUCK;
}

public Ability_PostThink_Post(id)
{
	if(!is_user_connected(id))
		return FMRES_IGNORED;
		
	new class = GetClass(id);
	if( class == 0 || !is_user_alive(id) )
		return FMRES_IGNORED;
		
	//Set our swim animation (dive effect)
	if(Ability_IsActive(id, A_DIVE))
	{
		entity_set_float(id, EV_FL_framerate, 0.1 );
		entity_set_int( id, EV_INT_sequence, 8 );	
	}
	return FMRES_IGNORED;
}

Ability_Turbo( id )
{
	new bool:bCanTurbo = Ability_IsActive(id, A_TURBO_QUICK);//g_iSprint[id] == 1;
	new Float:maxspeed = 225.0 * Ability_Strength(id, A_TURBO_QUICK);

	if(bCanTurbo)
	{
		static const Float:flTurboTime = TURBO_QUICK_LENGTH;
		static const Float:flResetTime = DELAY_TURBO_QUICK;
		new Float:timeleft = get_gametime() - Ability_GetDelay(id,A_TURBO_QUICK);//g_flTurboDelay[id];
		//new totalTime = floatround( (timeleft/flTurboTime) * 15.0 );
		
		new Float:flStrength = 1.0;
		new pclass = GetClass(id);
		new holder = GetBallData(BALL_HOLDER);
		new startTeam = GetBallData(BALL_START_TEAM);
		new team = get_user_team(id);
		
		if(pclass == CLASS_RUNNINGBACK && id == holder && g_iPlay == PLAY_STANDARD && team == startTeam)
			flStrength = get_pcvar_float(P_RUNNINGBACK);
				
		if(timeleft <= flTurboTime)
			maxspeed += 120.0 * flStrength;
		else if(timeleft > flResetTime)
			Ability_Remove(id, A_TURBO_QUICK);
	}	
	
	entity_set_float(id,EV_FL_maxspeed, maxspeed);
}
Ability_Jump( id, button, oldbutton )
{
	//static Float:flTime[MAX_PLAYERS];
	new bool:bDive = Ability_IsActive( id, A_DIVE );
	new bool:bPressedJump = (button & IN_JUMP) > 0;
	new bool:onground = on_ground(id);
	//if(!bPressedJump)
	//{
	new class = GetClass(id);
	new bool:bJump = Ability_IsActive( id, A_JUMP );
	if(bJump && onground)
	{
		Ability_Remove( id, A_JUMP );
		//Ability_SetDelay( id, A_JUMP, 0.0 );
	}
	else if(!bDive)
	{

		if( !(bPressedJump && !(oldbutton & IN_JUMP > 0)) )
			return;
			
		if( onground || (bJump && class != CLASS_SAFETY) || !Ability_Activate( id, A_JUMP )) 
			return;
		
		new Float:velocity[3];
		entity_get_vector(id,EV_VEC_velocity,velocity);
		velocity[2] = 250.0 * Ability_Strength( id, A_JUMP );//random_float(250.0,350.0);
		entity_set_vector(id,EV_VEC_velocity,velocity);
		
		Ability_Set(id, A_JUMP);
		/*
		new Float:gametime = get_gametime();
		new Float:currentDelay = Ability_GetDelay(id, A_JUMP );
		if(currentDelay == 0.0)
			currentDelay = gametime;
			
		Ability_SetDelay( id, A_JUMP, currentDelay );

		if(gametime - currentDelay > 0.2)
			return;
		
		if( !Ability_Activate( id, A_JUMP ) )
			return;
			
		new Float:vel[3];
		new Float:frametime;
		global_get( glb_frametime, frametime );
		entity_get_vector(id, EV_VEC_velocity, vel );
		if(vel[2] < 700.0 && vel[2] > 200.0)
			vel[2] += 700.0 * frametime * Ability_Strength(id, A_JUMP);
			
		entity_set_vector( id, EV_VEC_velocity, vel );
		
		Ability_Remove( id, A_JUMP );
		*/
	}	
}

Ability_Dive( id, button, oldbutton )
{
	new Float:gametime = get_gametime();
	new class = GetClass(id);
	
	
	if( class == CLASS_SAFETY )
	{
		new moveright = (button & IN_MOVERIGHT) > 0;
		new moveleft = (button & IN_MOVELEFT) > 0;
		new up = (button & IN_FORWARD) > 0;
		new down = (button & IN_BACK) > 0;
		new jump = (button & IN_JUMP) > 0;
		new oldjump = (oldbutton & IN_JUMP) > 0;
		//new onground = on_ground(id);
		
		new holder = GetBallData(BALL_HOLDER);
		if( holder == id )
			return;
			
		if( (moveright || moveleft) 
			&& !up 
			&& !down 
			&& jump 
			&& !oldjump )
		{
			if(Ability_Activate( id, A_OLDDIVE ))
			{
				new Float:vel[3];
				entity_get_vector( id, EV_VEC_velocity, vel );
				vel[0] *= get_pcvar_float(P_SAFETYDIVE);
				vel[1] *= get_pcvar_float(P_SAFETYDIVE);
				vel[2] = 250.0;
				entity_set_vector( id, EV_VEC_velocity, vel );
			}
		}
		return;
	}
	
	if( class != CLASS_RUNNINGBACK )
		return;
		
	new Float:currentDelay = Ability_GetDelay(id, A_DIVE);
	new Float:lastDiveTime = gametime - currentDelay;
	new Float:flDiveResetTime = 5.0;
	new bool:bDive = Ability_IsActive( id, A_DIVE );
	new bool:pressedDuck = (button & IN_DUCK) > 0;
	new onground = on_ground(id);
	
	if(bDive && onground)
	{
		//Sink player to ground
		if(lastDiveTime < 0.0)
		{
			new Float:vel[3];
			new Float:orig[3];
			entity_get_vector(id, EV_VEC_origin, orig );
			if(pressedDuck)
				orig[2] -= 15;
			else
				orig[2] -= 33;
				
			orig[2] = g_vSideLine[0][2];
			
			entity_set_vector(id, EV_VEC_origin, orig );
			entity_set_vector(id, EV_VEC_velocity, vel );
			
			Ability_SetDelay(id, A_DIVE, gametime );
		}
		
		//Stand player up.
		else if(lastDiveTime > 0.5)
		{
			new Float:orig[3];
			entity_get_vector(id, EV_VEC_origin, orig );
			
			orig[2] = g_vSideLine[0][2] + 36; //Ground origin + 36 (half height of player)
			
			entity_set_vector(id, EV_VEC_origin, orig );
			entity_set_float(id, EV_FL_framerate, 1.0 );
			entity_set_int( id, EV_INT_sequence, 75 );	
			entity_set_float(id, EV_FL_gravity, 1.0 );
			
			Ability_Remove( id, A_DIVE );
			Ability_SetDelay(id, A_DIVE, gametime );
			
		}
	}
	else if((!bDive && onground) || (class == CLASS_SAFETY))
	{
		if(class != CLASS_SAFETY && lastDiveTime < flDiveResetTime)
			return;
		
		new bool:pressedForward = (button & IN_FORWARD) > 0;
		//new bool:jump = (button & IN_JUMP > 0) && !(oldbutton & IN_JUMP > 0);
		if( !pressedForward || !pressedDuck)
			return;
			
		//Launch player forward (dive)
		if(!Ability_Activate( id, A_DIVE ))
			return;
			
		new Float:velocity[3];
		new Float:angle[3];
		new Float:origin[3], Float:vForward[3];
		new Float:pitch, Float:speed, Float:upVel;
			
		entity_get_vector(id, EV_VEC_v_angle, angle );
		entity_get_vector(id, EV_VEC_origin, origin );
			
		origin[2] += 10.0;
			
		//Use pitch angle between -20.0 and 15.0 for dive type
		pitch = angle[0];
		if(pitch > 15.0)		pitch = 15.0;
		else if(pitch < -20.0)	pitch = -20.0;
			
		pitch = (pitch-10.0) / -30.0;
			
		//Adjust speeds with default and pitch speed
		speed = (300.0 * (1.0-pitch)) + (200.0 * Ability_Strength(id, A_DIVE));
		upVel = 150.0 + (140.0 * (pitch));
		
		angle[0] = 0.0;
		angle[2] = 0.0;
		angle_vector( angle, ANGLEVECTOR_FORWARD, vForward);
			
		//Add to our velocity
		velocity[0] = vForward[0] * speed;
		velocity[1] = vForward[1] * speed;
		velocity[2] = upVel;
			
		entity_set_origin(id, origin );
		entity_set_vector(id, EV_VEC_velocity, velocity );
		entity_set_float(id, EV_FL_gravity, 0.6 );	
			
		Ability_SetDelay(id, A_DIVE, gametime + 100.0 );
	}	
	return;
}

bool:ShouldGiveBonus()
{
	new holder = GetBallData(BALL_HOLDER);
	if(is_user_alive(holder))
	{
		new id;
		new Float:origin[3];
		entity_get_vector(holder, EV_VEC_origin, origin );
		
		new Float:holderYard = GetYard( origin[1] );
		new Float:yard;
		new ballTeam = GetBallData( BALL_TEAM );
		new team;
		
		for(id=1;id<=g_iMaxplayers;id++)
		{
			if(GetDefaultClass(id) == 0 || id == holder)
				continue;
			if(!is_user_alive(id))
				continue;
			
			team = get_user_team(id);
			if(team == ballTeam)
				continue;
				
			entity_get_vector(id, EV_VEC_origin, origin );
			yard = GetYard( origin[1] );
			if(yard > holderYard)
				return false;
		}	
		return true;
	}
	return false;
}

public Touch_PlayerToPlayer(p1, p2)
{
	/*
	new class = g_iPlayerClass[p2];
	//new gstate = GetGameState();
	if(g_iGameMode == GAME_INPLAY && g_bRunDrive[p1] && class != -1)
	{
		new Float:origin[3];
		new Float:otherOrig[3];
		new Float:newVel[3];
		entity_get_vector(p1, EV_VEC_origin, origin );
		entity_get_vector(p2, EV_VEC_origin, otherOrig );
		new Float:dist = floatsqroot( GetDist( origin, otherOrig ) );
		newVel[0] = ((origin[0] - otherOrig[0]) / dist) * 600.0;
		newVel[1] = ((origin[1] - otherOrig[1]) / dist) * 600.0;
		newVel[2] = 400.0;
		entity_set_vector(p2, EV_VEC_velocity, newVel );
		
	}
	*/
}
