#pragma dynamic 10000//1048576  //I used to much memory =(


#include <amxmodx>
#include <amxmisc>
//#include <csdm>
#include <engine>
#include <fakemeta>
#include <cstrike>
#include <fun>
#include <hamsandwich>

//User Editable settings.
#include "fb_settings.sma"

//Constants
#include "fb_const.sma"

//Globals
#include "fb_globals.sma"

//Helper Functions
#include "fb_stocks.sma"

//Main Files
#include "fb_game.sma"
#include "fb_pregame.sma"
#include "fb_rules.sma"
#include "fb_class.sma"
#include "fb_publicclass.sma"

#include "fb_ball.sma"
#include "fb_map.sma"
#include "fb_spawn.sma"
#include "fb_ability.sma"
#include "fb_stats.sma"
#include "fb_vote.sma"
#include "fb_ui.sma"
#include "fb_effects.sma"
#include "fb_crap.sma"

static const TITLE[] 	= "Football Jam";
static const VERSION[] 	= "1.2";
static const AUTHOR[] 	= "OneEyed";


public plugin_init()
{
	register_plugin(TITLE, VERSION, AUTHOR);	
	register_cvar("fb_version", VERSION, FCVAR_SPONLY);
	
	g_iMaxplayers = get_maxplayers();
	
	
	P_GAMETIME 		= register_cvar( "fb_gametime", 			"3.0" 	);
	P_COUNTDOWNTIME = register_cvar( "fb_countdowntime", 		"10" 	);
	P_PLAYERS		= register_cvar( "fb_tournament_players", 	"5" 	);
	P_VOTETIME 		= register_cvar( "fb_votetime", 			"10" 	);
	P_PLAYERSNEEDED = register_cvar( "fb_playersneeded", 		"2" 	);
	P_SAFETYDIVE = register_cvar( "fb_safetydive", 				"1.7"   );
	P_RUNNINGBACK = register_cvar( "fb_runningback", 			"1.0"   );
	
	g_msgCorpse 		= get_user_msgid( "ClCorpse" );
	g_msgDeathMsg 		= get_user_msgid( "DeathMsg" );
	g_msgSayText 		= get_user_msgid( "SayText" );
	//g_msgScoreAttrib 	= get_user_msgid( "ScoreAttrib" );
	g_msgRoundTime		= get_user_msgid( "RoundTime" );
	//g_msgResetHud 		= get_user_msgid( "ResetHUD" );
	g_msgStatusIcon 	= get_user_msgid( "StatusIcon" );
	
	register_concmd("fb_startgame", 	"cmdStartGame", 	ADMIN_KICK, "Starts Game in Current Mode" 	);
	register_concmd("fb_public", 		"cmdPublic", 		ADMIN_KICK, "Sets public mode" 				);
	register_concmd("fb_tournament", 	"cmdTournament", 	ADMIN_KICK, "Sets tournament mode" 			);
	register_concmd("fb_endgame", 		"cmdEndGame", 		ADMIN_KICK, "Ends a game currently in progress." );
	
	register_clcmd( "say stats",	"cmdStatDisplay" 	);
	register_clcmd( "say stat",		"cmdStatDisplay" 	);
	register_clcmd( "say .stats",	"cmdStatDisplay" 	);
	register_clcmd( "say /stats",	"cmdStatDisplay" 	);
	register_clcmd( "say .stat",	"cmdStatDisplay" 	);
	register_clcmd( "say /stat",	"cmdStatDisplay" 	);
	
	register_clcmd( "say .help", 	"cmdHelp" 			);
	register_clcmd( "showbriefing", "cmdHelp" 			);
	register_clcmd( "radio3", 		"cmdChangeClass" 	);
	register_clcmd( "say .class", 	"cmdChangeClass" 	);
	register_clcmd( "say /class", 	"cmdChangeClass" 	);
	register_clcmd( "say !class", 	"cmdChangeClass" 	);
	register_clcmd( "radio1", 		"cmdChangePosition" );
	register_clcmd( "drop",			"cmdTurbo"			);
	//register_clcmd("_special", "cmdKill" );
	//register_clcmd("special", "cmdKill" );
	
	
	set_task( 0.5, 	"GameTimer", _, _, _, "b");
	set_task( 0.55, "LinePaint", _, _, _, "b");
	set_task( 0.2, 	"HudPaint1", _, _, _, "b");
	set_task( 0.48, "HudPaint2", _, _, _, "b");
	set_task( 0.51, "HudPaint3", _, _, _, "b");
	set_task( 0.53, "HudPaint4", _, _, _, "b");
	set_task( 0.1, 	"GameThink", _, _, _, "b");
	
	
	register_think( "PlayerCamera", "Think_PlayerCamera" );
	register_think( "grenade",	"ThinkGrenade"	);
	register_think( "football",	"ThinkFootball"	);
	
	
	register_touch( "worldspawn", 				"football",		"Touch_World");
	register_touch( "func_wall", 				"football",		"Touch_World");
	register_touch( "func_door", 				"football",		"Touch_World");
	register_touch( "func_door_rotating", 		"football", 	"Touch_World");
	register_touch( "func_wall_toggle", 		"football",		"Touch_World");
	register_touch( "func_breakable", 			"football",		"Touch_World");
	register_touch( "fb_func_teamfieldgoal", 	"football",		"Touch_FieldGoal" );
	register_touch( "fb_func_teamgoal", 		"football",		"Touch_EndZone");
	register_touch( "fb_outofbounds",	   	 	"football", 	"Touch_OutofBound" );
	register_touch( "fb_inbounds", 				"football", 	"Touch_InBound" );
	register_touch( "football", 				"player", 		"Touch_Player" );
	register_touch( "fb_func_teamgoal", 		"player",		"Touch_EndZone");
	register_touch( "fb_outofbounds",			"player", 		"Touch_OutofBound" );
	register_touch( "fb_inbounds", 				"player", 		"Touch_InBound" );
	register_touch( "player", 					"player", 		"Touch_PlayerToPlayer");
	register_touch( "grenade",					"player", 		"Touch_Grenade" );
	
	//HAM_PRIMARY_ATTACK = RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "PrimaryAttack", 1);
	//HAM_SECONDARY_ATTACK = RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_knife", "SecondaryAttack", 1);
	
	RegisterHam(Ham_Spawn, "player", "Player_PreSpawn", 1);
	RegisterHam(Ham_Spawn, "player", "Player_PostSpawn", 1 );
	RegisterHam(Ham_Killed, "player", "Player_Killed", 1 );
	register_forward( FM_PlayerPreThink,	"Ability_PreThink");
	register_forward( FM_PlayerPreThink,	"Ability_PreThink_Post", 1);
	//register_forward( FM_PlayerPostThink,	"Ability_PostThink");
	register_forward( FM_PlayerPostThink,	"Ability_PostThink_Post", 1);
	
	register_forward( FM_CmdStart, "FMCmdStart" );
	register_message( g_msgCorpse, "CorpseBlock" );
	register_event( "DeathMsg",	"Event_DeathMsg", 	"a");
	register_event( "Damage",	"Event_Damage", 	"b", "2!0", "3=0", "4!0" );
	//register_event( "Damage", "Event_Damage", "be" )
	
	
	Map_SortSpawns();
	Map_SetSideLines();
	Map_SetYardSize();
	
	Class_CreateMenus();
	
	CreatePlayMenus();
	
	Football_Create();
	

	//register_clcmd("say","handle_say");
	//register_clcmd("say_team","handle_say");
	
	//register_message( g_msgResetHud, "msgResetHUD" );
	//register_message( g_msgRoundTime, "msgRoundTime" );

	
	//FORWARD_BEGIN_PLAY = CreateMultiForward("BeginPlay",ET_IGNORE, FP_CELL);
	//FORWARD_TOURNAMENTMODE = CreateMultiForward("TournamentMode",ET_IGNORE, FP_CELL);

	
 	//Grenade Fixes - Models and Radio Messages
	register_menucmd(register_menuid("Team_Select",1), (1<<0)|(1<<1)|(1<<4)|(1<<5), "team_select");
	register_event("ShowMenu", "menuclass", "b", "4&CT_Select", "4&Terrorist_Select");
  	register_event("VGUIMenu", "menuclass", "b", "1=26", "1=27");
	register_clcmd("jointeam 1", "vgui_jointeamone");
	register_clcmd("jointeam 2", "vgui_jointeamtwo");
	register_clcmd("jointeam 5", "vgui_jointeamfive" );
	
	register_clcmd("say","handle_say")
	register_clcmd("say_team","handle_say")
	
	register_event("CurWeapon", "CurWeapon_FixViewModel", "b", "1=1");
	register_message(get_user_msgid("SendAudio"),	"msg_sendaudio");
	register_message(get_user_msgid("TextMsg"),		"msg_textmsg");
	register_forward(FM_EmitSound, "EmitSound")

	register_forward(FM_ClientKill, "Forward_ClientKill");
	//register_clcmd("test", "cmdTest" );
	//register_clcmd("test", "cmdTest2" );
	//register_clcmd("test3", "cmdTest3" );
	//register_clcmd("test4", "cmdTest4" );
	//register_clcmd("test5", "cmdTest5" );
	//register_clcmd("say /effect", "cmdEffect" );
	//register_clcmd( "say /kill", "cmdKill" );
	return PLUGIN_HANDLED
}


public Forward_ClientKill(id)
{
    return FMRES_SUPERCEDE;
}  

BlockAttack(id, Float:blockTime=(-0.001))
{
	if(id == 0)
	{
		for(id=1;id<=g_iMaxplayers;id++)
			if(GetDefaultClass(id) > 0)
				BlockAttack(id, blockTime);
		return;
	}
	
	if(!is_user_connected(id) || GetDefaultClass(id) == 0)
		return;

	set_pdata_float( id, 83, blockTime );
}

public PrimaryAttack(knife)
{
	new owner = entity_get_edict(knife, EV_ENT_owner);
	new class = GetClass(owner);
	
	if(class == CLASS_LINEMAN)
	{
		set_pdata_float(knife, 46, 0.175);
		//set_pdata_float(weap, 47, -0.001);
	}
	else 
	{
		new startTeam = GetBallData( BALL_START_TEAM );
		new team = get_user_team(owner);
		
		new Float:origin[3];
		entity_get_vector( owner, EV_VEC_origin, origin );
		new Float:yard = GetYard( origin[1] );
		
		if(!g_bPassedScrimmage && (team != startTeam || yard > g_flCurrentYard))//class == CLASS_RECEIVER)
		{
			set_pdata_float(knife, 46, 0.6);
			set_pdata_float(knife, 47, 0.6);
		}
	}
	
	//new Float:prim = get_pdata_float(knife, 46);
	//client_print(0, print_chat, "Primary Delay = %f", prim);
	//new Float:secon = get_pdata_float(knife, 47);
	//client_print(0, print_chat, "Secondary Delay = %f", secon);
}

public SecondaryAttack(knife)
{
	new owner = entity_get_edict(knife, EV_ENT_owner);
	new class = GetClass(owner);
	
	if(class != CLASS_LINEMAN)
	{
		new startTeam = GetBallData( BALL_START_TEAM );
		new team = get_user_team(owner);
		
		new Float:origin[3];
		entity_get_vector( owner, EV_VEC_origin, origin );
		new Float:yard = GetYard( origin[1] );
		
		if(!g_bPassedScrimmage && (team != startTeam || yard > g_flCurrentYard))
		{
			set_pdata_float(knife, 46, 2.0);
			set_pdata_float(knife, 47, 2.0);
		}
	}
	
	//new Float:prim = get_pdata_float(knife, 46);
	//client_print(0, print_chat, "Primary Delay = %f", prim);
	//new Float:secon = get_pdata_float(knife, 47);
	//client_print(0, print_chat, "Secondary Delay = %f", secon);
}

public cmdEndGame( id, level, cid )
{
	if(!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED;
		
	EndGame();
	new name[32], steamid[32];
	get_user_authid(id,steamid,31);
	get_user_name(id,name,31);
	client_print(0,print_chat,"Football game ended by %s.",name);
	log_amx( "[FB Jam] - Game ended by %s - %s", name, steamid );
	return PLUGIN_HANDLED;
}

public cmdStartGame( id, level, cid )
{
	if(!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED;
		
	ClearTasks();
	
	g_bExtraPoint = false;
	g_iGameMode = GAME_NONE;
	g_bGameStart = false;
	g_iQuarter = 0;
	
	g_iCountdownTimer = get_pcvar_num( P_COUNTDOWNTIME );	
	BeginCountdown(random_num(1,2));
	g_iGameMode = GAME_PREGAME;	

	new name[32], steamid[32];
	get_user_authid(id,steamid,31);
	get_user_name(id,name,31);
	client_print(0,print_chat,"Football game started by %s.",name);
	log_amx( "[FB Jam] - Game started by %s - %s", name, steamid );
	
	return PLUGIN_HANDLED;
}


public handle_say(id) 
{
	if(!g_bTournamentMode || g_bGameStart)
		return PLUGIN_CONTINUE;
		
	new said[192]//, help[7]
	read_args(said,192)
	remove_quotes(said)
	//client_print( id, print_chat, "-- SAID SOMETHING");
	new cmdReady[32], info[32];
	parse(said, cmdReady, 31, info, 31);
	
	
	if(containi(cmdReady, ".ready") != -1)
		Ready[id] = true
	else if(containi(cmdReady, ".wait") != -1)
		Ready[id] = false	

	return PLUGIN_CONTINUE;
}

public cmdTournament( id, level, cid )
{
	if(!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED;	
		
	g_bTournamentMode = true;
	
	ClearTasks();
	
	g_bExtraPoint = false;
	g_iGameMode = GAME_NONE;
	g_bGameStart = false;
	g_iQuarter = 0;
	
	//new team;
	new id;
	for(id=1;id<=g_iMaxplayers;id++)
	{
		ClearPlayer(id);
		
		g_HudMsg1[id][0] = 0;
		if(is_user_alive(id))
			user_kill(id);
	}
	
	
	g_HudMsg2[0] = 0;
	g_HudMsg3[0] = 0;
	g_HudMsg4[0] = 0;
	
	new name[32], steamid[32];
	get_user_authid(id,steamid,31);
	get_user_name(id,name,31);
	client_print(0,print_chat,"%s set mode to Tournament.",name);
	log_amx( "[FB Jam] - Tournament mode activated by %s - %s", name, steamid );
	return PLUGIN_HANDLED;
}

public cmdPublic( id, level, cid )
{
	if(!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED;	
		
	g_bTournamentMode = false;
	
	ClearTasks();
	
	g_bExtraPoint = false;
	g_iGameMode = GAME_NONE;
	g_bGameStart = false;
	g_iQuarter = 0;
	
	//new team;
	new id;
	for(id=1;id<=g_iMaxplayers;id++)
	{
		ClearPlayer(id);
		
		g_HudMsg1[id][0] = 0;
		
		if(is_user_alive(id))
			user_kill(id);
	}
	
	
	g_HudMsg2[0] = 0;
	g_HudMsg3[0] = 0;
	g_HudMsg4[0] = 0;
	
	new name[32], steamid[32];
	get_user_authid(id,steamid,31);
	get_user_name(id,name,31);
	client_print(0,print_chat,"%s set mode to Public.",name);
	log_amx( "[FB Jam] - Public mode activated by %s - %s", name, steamid );
	return PLUGIN_HANDLED;
}

ClearTasks()
{
	remove_task(TASK_FINAL_GOAL);
	remove_task(TASK_FINAL_FG);
	remove_task(TASK_BEGIN_QUARTER);
	remove_task(TASK_BEGINPLAY);
	remove_task(TASK_PLAYCLOCK);
	remove_task(TASK_RESETGAME);
	remove_task(TASK_RANDOMTEAMS);
	remove_task(TASK_COUNTDOWN);
}
public cmdKill(id)
{
	//entity_set_int( id, EV_INT_deadflag, DEAD_DYING );
	//client_print(0,print_chat,"Hello there" );
	return PLUGIN_HANDLED;	
}

public cmdTest5(id)
{
	client_print( id,print_console, "Weapon ID = %i" ,g_iWeapon[id]);
	
	//get_pdata_float(g_iWeapon[id], 76, get_gametime());
	//get_pdata_float(weap, 48, 0.0);
		
	new i;
	new Float:val;
	new Float:gametime = get_gametime();
	for(i=60;i<90;i++)
	{
		val = get_pdata_float(id,i);
		
		client_print(id,print_console, "Offset %i = %f          | Gametime %f", i, val, gametime );	

	}
	
	/*
	new flags = entity_get_int( id, EV_INT_flags );
	
	if( flags & FL_FROZEN > 0 )
	{
		client_print(0,print_chat, "Unfrozen" );
		FreezePlayer( id, false );
	}
	else
	{
		
		FreezePlayer( id, true );
	}
	*/
	/*
	new Float:origin[3];
	entity_get_vector(id, EV_VEC_origin, origin );
	
	new ball = GetBallData( BALL_ID );
	
	origin[2] += 100.0;
	origin[1] += 100.0;
	entity_set_origin(ball, origin );
	*/
}
public cmdTest(id)
{
	//So we don't mess up anything.
	remove_task(TASK_COUNTDOWN); 
	remove_task(TASK_BEGINPLAY);
	remove_task(TASK_PLAYCLOCK);
	
	ChangePossession( T );
	g_flCurrentYard = 30.0;
	
	BeginPlay( PLAY_KICKOFF );
	
	return PLUGIN_HANDLED;
}

public cmdTest2(id)
{
	//So we don't mess up anything.
	remove_task(TASK_COUNTDOWN); 
	remove_task(TASK_BEGINPLAY);
	remove_task(TASK_PLAYCLOCK);
	
	ChangePossession( random_num(1,2) );
	g_flCurrentYard = 45.0;
	
	BeginPlay( PLAY_FIELDGOAL );
	
	return PLUGIN_HANDLED;
}

public cmdTest3(id)
{
	//So we don't mess up anything.
	remove_task(TASK_COUNTDOWN); 
	remove_task(TASK_BEGINPLAY);
	remove_task(TASK_PLAYCLOCK);
	
	ChangePossession( T );
	g_flCurrentYard = 50.0;
	
	BeginPlay( PLAY_STANDARD );
	
	return PLUGIN_HANDLED;
}

public cmdTest4(id)
{
	//So we don't mess up anything.
	remove_task(TASK_COUNTDOWN); 
	remove_task(TASK_BEGINPLAY);
	remove_task(TASK_PLAYCLOCK);
	
	ChangePossession( T );
	g_flCurrentYard = 10.0;
	
	BeginPlay( PLAY_PUNT );
	
	return PLUGIN_HANDLED;
}

public plugin_natives()
{
	//Register natives	
}



public plugin_precache()
{
	
	precache_model("models/football/p_football.mdl");
	precache_model("models/football/v_football.mdl");
	//precache_model("models/football/p_football_TEST7.mdl");
	//precache_model("models/football/v_football_TEST5.mdl");
	
	//Knuckles models/sounds
	precache_model("models/p_bknuckles.mdl")
	precache_model("models/v_bknuckles.mdl")
	precache_sound("bknuckles/knife_hit1.wav")
	precache_sound("bknuckles/knife_hit2.wav")
	precache_sound("bknuckles/knife_hit3.wav")
	precache_sound("bknuckles/knife_hit4.wav")
	precache_sound("bknuckles/knife_stab.wav")
	
	precache_sound("fjam/nfl.wav");
	
	g_fxWave = engfunc( EngFunc_PrecacheModel,"sprites/shockwave.spr");
	g_fxBeam = precache_model("sprites/laserbeam.spr");
	//g_fxFootball = precache_model("models/football/w_football_TEST5.mdl");
	g_fxFootball = precache_model("models/football/w_football2.mdl");
	g_fxBeamSprite = precache_model("sprites/zbeam4.spr")	
	//g_fxPowerUp = precache_model("sprites/fjam/esf_powerup.spr");
	//g_fxFire = precache_model("sprites/xfireball3.spr")
	
	//precache_sound("ambience/flameburst1.wav")
}

public cmdEffect(id)
{
	//new ent = create_entity("info_target");
	
	//entity_set_string(ent,EV_SZ_classname,"SpecialEffect");
		
	//entity_set_model(ent,"sprites/fjam/onfire2.spr");
		
	//entity_set_int( ent, EV_INT_solid, SOLID_NOT);
	//DispatchSpawn(ent);
	
	//new Float:origin[3];
	//entity_set_origin(ent, origin );
	
	//entity_set_float( ent, EV_FL_nextthink, get_gametime() );
	//emit_sound(id,CHAN_ITEM, "ambience/flameburst1.wav", 0.6, ATTN_NORM, 0, PITCH_NORM)
	
	//entity_set_int(ent,EV_INT_renderfx,kRenderTransAdd);
	//new Float:RenderColor[3];
	//RenderColor[0] = float(255);
	//RenderColor[1] = float(255);
	//RenderColor[2] = float(255);
	//entity_set_vector(ent,EV_VEC_rendercolor,RenderColor);
	//entity_set_int(ent,EV_INT_rendermode,kRenderFxNone);
	//entity_set_float(ent,EV_FL_renderamt,float(255));
	//
	//entity_set_int(ent, EV_INT_sequence, 1);
	//entity_set_float(ent, EV_FL_framerate, 1.0 );
	//entity_set_float(ent, EV_FL_animtime, 2.0 );
	
	//entity_set_int(ent, EV_INT_movetype, MOVETYPE_FOLLOW);
	//entity_set_edict(ent, EV_ENT_aiment, id);	
}
