#if defined _fb2_included
  #endinput
#endif
#define _fb2_included

#define MAX_PLAYERS 		33
#define TEAMS				5

#define T 					1
#define CT					2

#define _FORWARD 			1
#define _BACK				-1

#define TASK_FINAL_GOAL		1000
#define TASK_FINAL_FG		2000
#define TASK_BEGIN_QUARTER	3000
#define TASK_BEGINPLAY		4000
#define TASK_PLAYCLOCK		5000
#define TASK_RESETGAME		6000
#define TASK_RANDOMTEAMS	7000
#define TASK_COUNTDOWN		9999

#define TASKTIME_RANDOMTEAMS	5.0

//used with g_flBallYOrig as first array index
#define KICKOFF_BALLPOS 	0
#define FIELDGOAL_BALLPOS 	1	

#define SPAWN_POSITIONS		5
#define MAX_SPAWNS 			10	//Map team class spawns

#define VOTE_EXTRAPOINT 7000
#define VOTE_FOURTHDOWN 8000

#define BALL_GRAVITY 		0.5 	//Default( 0.5  ) - Gravity Percentage: 1.0 = 100% of gravity, 0.0 = No Gravity

#define PUBLIC_QB_MIN_YARDS	2.0

enum //Hud Channels
{
	CHANNEL1 = 1,
	CHANNEL2,
	CHANNEL3,
	CHANNEL4	
}

enum //Zones
{
	OUTOFBOUND = 0,
	INBOUND,
	ENDZONE
}


enum //Events
{
	DOWN = 1,			//Down at yard
	TOUCHBACK,			//Ran out behind endzone
	OUTOFBOUNDS, 		//Ran out of bounds
	TWOMINUTE,			//two minute warning
	GAME_START,
	GAME_END_QUARTER,	//End of game
	
	//Scoring Events
	SCORE_EVENT,
	SCORE_FIELDGOAL,	//3 Points
	SCORE_TOUCHDOWN,	//6 points
	SCORE_EXTRAPOINT,	//1 point
	SCORE_TWOPOINT,		//2 points
	SCORE_SAFETY,		//2 points
	
	//Failed Events
	FAIL_EVENT,			//Referenced for coders
	FAIL_FOURTH,		//Failed 4th down
	FAIL_FIELDGOAL,		//Failed 3 pt FG attempt
	FAIL_EXTRAPOINT,	//Failed extra pt FG
	FAIL_TWOPOINT,		//Failed extra pt 2 pt conversion
	
	FG_NOGOOD,
	
	//Kick failures
	KICK_EVENT,			//Referenced for coders
	KICK_NEGATIVEYARD,	//Kicked in the opposite direction
	KICK_SHORT,			//Touched less than X yards from kicking yard.
	KICK_OUTOFBOUNDS,	//Kick landed out of bounds.
	KICK_TOUCHBACK,		//Team kneeled/ran out in endzone
	KICK_ROLLED_OUT,	//Ball rolled out of bounds
	//KICK_ROLLED_OUT_20,
	
	//Punt failures
	PUNT_EVENT,			//Referenced for coders
	PUNT_NEGATIVEYARD,  //Kicked opposite direction
	PUNT_RETURNTOUCH,	//Return team touched ball
	PUNT_OUTOFBOUNDS,	//Ball landed out of bounds
	PUNT_TOUCHBACK,		//Ball landed out of bounds at endzone. (several ways for this to happen)
	PUNT_ROLLED_OUT,	//Ball rolled out of bounds
	
	//Pass failures
	PASS_CATCH_OUTOFBOUNDS,	//Pass caught out of bounds
	PASS_INCOMPLETE,		//Pass missed by all.
	PASS_OUTOFBOUNDS,		//Pass landed out of bounds.

	//Penalties
	PENALTY_EVENT,
	PENALTY_DELAYOFGAME,	//Team took to long to snap ball.
	PENALTY_PASSINT,		//defense knifed receiver with ball in air headed his way
	PENALTY_OFFSIDES,		//Player on wrong side of scrimmage after 2nd hut
	
	REFEREE_COUNT
}

enum //Stats
{
	S_PASS_ATTEMPT = 0,
	S_PASS_COMPLETE,
	S_PASS_YARDS,
	S_PASS_FIRSTDOWN,
	S_PASS_INTERCEPT,
	S_PASS_FUMBLE,
	S_PASS_FUMBLE_RECOVER,	
	S_PASS_SACK,
	S_PASS_SACK_YARDS,
	S_PASS_LONG,
	S_PASS_LONG_TD,
	S_PASS_TD,
	
	S_RECV_RECEIVES,
	S_RECV_YARDS,
	S_RECV_FIRSTDOWN,
	S_RECV_LONG,
	S_RECV_LONG_TD,
	S_RECV_TD,
	
	S_RUSH_ATTEMPT,
	S_RUSH_YARDS,
	S_RUSH_FIRSTDOWN,
	S_RUSH_LONG,
	S_RUSH_LONG_TD,
	S_RUSH_TD,
	
	S_LINEMAN_SACK_ALLOWED,
	S_LINEMAN_BLOCK,
	S_LINEMAN_PANCAKE,
	
	S_DEF_SACK,
	S_DEF_SACKASSIST,
	S_DEF_TACKLE,
	S_DEF_TACKLE_ASSIST,
	S_DEF_FUMBLE_FORCE,
	S_DEF_FG_BLOCK,
	S_DEF_PUNT_BLOCK,
	
	S_FUMBLE,			
	S_FUMBLE_RECOVER,
	
	S_TURNOVER,
	S_TURNOVER_YARDS,		
	S_TURNOVER_TD,			
	S_TURNOVER_LONG,		
	S_TURNOVER_LONG_TD,		
	
	S_INT,
	S_INT_YARDS,
	S_INT_TD,
	S_INT_LONG,
	S_INT_LONG_TD,
	
	S_RETURN_PUNT,
	S_RETURN_PUNT_YARDS,
	S_RETURN_PUNT_TD,
	S_RETURN_PUNT_LONG,
	S_RETURN_PUNT_LONG_TD,
	
	S_RETURN_KICK,
	S_RETURN_KICK_YARDS,
	S_RETURN_KICK_TD,
	S_RETURN_KICK_LONG,
	S_RETURN_KICK_LONG_TD,
	
	S_PUNT_ATTEMPT,
	S_PUNT_YARDS,
	S_PUNT_OUTOFBOUND,
	S_PUNT_TOUCHBACK,
	S_PUNT_IN20,
	S_PUNT_BLOCK,
	S_PUNT_LONG,
	
	S_FG_ATTEMPT_0,
	S_FG_MADE_0,
	S_FG_ATTEMPT_20,
	S_FG_MADE_20,
	S_FG_ATTEMPT_30,
	S_FG_MADE_30,
	S_FG_ATTEMPT_40,
	S_FG_MADE_40,
	S_FG_ATTEMPT_50,
	S_FG_MADE_50,
	S_FG_YARDS,
	S_FG_LONG,
	S_FG_BLOCK,
	
	S_KICK_ATTEMPT,
	S_KICK_OUTOFBOUND,
	S_KICK_TOUCHBACK,
	S_KICK_ONSIDE_ATTEMPT,
	S_KICK_ONSIDE_RECOVERED,
	S_KICK_RETURN,
	S_KICK_RETURN_TD,
	S_KICK_RETURN_YARDS,
	
	S_TOTAL_COUNT	//USED FOR ARRAY
}

enum //Formations
{
	OFFENSE = 0,
	DEFENSE,
	KRECEIVE,
	KRETURN,
	PUNT,
	PUNTRETURN,
	FIELDGOAL,
	FIELDGOALBLOCK,
	FORMATION_COUNT
}

enum //Game Mode
{
	GAME_NONE = 0,
	GAME_PRACTICE,
	GAME_PREGAME,
	GAME_INPLAY,
	GAME_HALFTIME,
	GAME_PENALTY,
	GAME_EXTRA,
	GAME_ENDGAME
}


// -Extra point plays enable g_bExtraPoint
enum //Play Types
{
	PLAY_NONE = 0,
	PLAY_STANDARD,
	PLAY_FIELDGOAL,
	PLAY_PUNT,
	PLAY_KICKOFF,
	PLAY_COUNT
}

enum //Ball Data
{
	BALL_ID = 0,
	BALL_FLY,
	BALL_PASS,
	BALL_FLY_DELAY,
	BALL_SPIN,
	BALL_TEAM,
	BALL_START_TEAM,
	BALL_DIRECTION,
	BALL_HOLDER,
	BALL_OWNER,
	
	BALL_FUMBLE,
	
	BALL_THROW_PLAYER,	//Player who threw ball
	BALL_THROW_FLY,		//Fly type player threw
	BALL_THROW_CATCHER,	//Person who caught ball
	
	BALL_COUNT
}	

enum //Pass Types
{
	PASS_BOMB = 0,
	PASS_BULLET	
}

enum //Ball Fly Types
{
	FLY_NONE = 0,
	FLY_DEAD,
	FLY_FUMBLE,
	FLY_LATERAL,
	FLY_PITCH,
	FLY_PASS,
	FLY_HANDOFF,
	FLY_PUNT_HOLD,
	FLY_PUNT,
	FLY_KICK_HOLD,
	FLY_KICK,
	FLY_FG_HOLD,
	FLY_FG
}

enum //Ball Spin types
{
	SPIN_NONE = 0,
	SPIN_SPIRAL,
	SPIN_VERTICAL,
	SPIN_HORIZONTAL,
	SPIN_VERT_SPIN,
	SPIN_WOBBLE_SLOW,
	SPIN_WOBBLE
}

enum //Abilities
{
	A_NONE = 0,
	A_TURBO_QUICK,
	A_TURBO_LONG,
	A_OLDDIVE,
	A_DIVE,
	A_JUMP,
	A_QUICKTACKLE,
	A_STIFFARM,
	A_THROW,
	A_TACKLED,
	
	A_COUNT	//NOT USED
}

enum //Class Positions
{
	//Regular Positions
	CLASS_NONE = 0,
	CLASS_RECEIVER,
	CLASS_RUNNINGBACK,
	//CLASS_LINE_END,
	CLASS_LINEMAN,	
	
	//Possible extra special positions
	CLASS_COACH,
	CLASS_BENCH,
	
	//Specials
	CLASS_QUARTERBACK,
	CLASS_SAFETY,
	CLASS_KICKER,
	
	//CLASS_ALT_RB,	//Running Back Alternate
	//CLASS_ALT_LB,	//Line Backer Alternate
	
	//NOT USED
	CLASS_COUNT
}

