/*
//Call this wherever you want.
Create_PlayerCamera( id )
{
	
	new entid = create_entity("info_target");
		
	
	
	entity_set_string(entid,EV_SZ_classname,"PlayerCamera");
	entity_set_model(entid,"models/player/arctic/arctic.mdl");//w_usp.mdl");
	entity_set_int( entid, EV_INT_solid, SOLID_TRIGGER);
	entity_set_int( entid, EV_INT_movetype, MOVETYPE_TOSS );
		
	new Float:MinBox[3], Float:MaxBox[3];
	MinBox[0] = -20.0; MinBox[1] = -20.0; MinBox[2] = -20.0;
	MaxBox[0] = 20.0; MaxBox[1] = 20.0; MaxBox[2] = 20.0; 
	entity_set_size( entid, MinBox, MaxBox );
	
	
	new Float:vel[3];
	new Float:origin[3];
	new Float:viewofs[3];
	
	
	entity_get_vector( id, EV_VEC_view_ofs, viewofs );
	entity_get_vector( id, EV_VEC_origin, origin );
	entity_get_vector( id, EV_VEC_velocity, vel );
	
	
	origin[0] += viewofs[0];
	origin[1] += viewofs[1];
	origin[2] += viewofs[2];
	
	entity_set_origin( entid, origin );
	entity_set_vector( entid, EV_VEC_velocity, vel );
	
	
	 //Set owner
	entity_set_edict( entid, EV_ENT_owner, id );
	//Don't draw
	entity_set_int( entid, EV_INT_rendermode, kRenderTransTexture);
	entity_set_float( entid, EV_FL_renderamt, 0.0);
	
	
	//Think!
	entity_set_float( entid, EV_FL_nextthink, get_gametime() );
		
	//Attach our view to this entity.
	attach_view( id, entid ); 
}
*/
public Think_PlayerCamera( entid )
{
	new id = entity_get_edict( entid, EV_ENT_owner );
	
	//client_print(id,print_center,"Thinking...." );
	//Kill our entity if we hit USE key
	//new buttons = entity_get_int( id, EV_INT_button );
	new Float:gametime = get_gametime();
	
	if(!Ability_IsActive( id, A_TACKLED ))
	{
		//client_print(id, print_chat, "Think_PlayerCamera END" );
		entity_set_int( id, EV_INT_solid, SOLID_BBOX );
		entity_set_int( id, EV_INT_effects, entity_get_int( id, EV_INT_effects ) & ~EF_NODRAW );
		attach_view( id, id );
		remove_entity(entid);
		return;
	}

	//For thinking only
	entity_set_float( entid, EV_FL_nextthink, gametime );
	
	
	if(gametime - Ability_GetDelay(id,A_TACKLED) >= 0.0)
	{
		Ability_Remove( id, A_TACKLED );	
		return;
	}
	new Float:angle[3], Float:origin[3];
	new Float:frametime = get_global_float(GL_frametime);
	
	entity_get_vector( entid, EV_VEC_origin, origin );
	entity_get_vector( id, EV_VEC_v_angle, angle );

	if( origin[2] < g_vSideLine[0][2] + 20.0 )
	{
		origin[2] = g_vSideLine[0][2] + 20.0;
		entity_set_int( entid, EV_INT_movetype, MOVETYPE_NONE );	
	}
	
	if( angle[2] != -90.0 )
	{
		if( on_ground( entid ) )
			angle[2] = -90.0;
		else 
		{
			angle[2] -= (90.0 * frametime);
			if(angle[2] > -90.0)
				angle[2] = -90.0;
		}
	}
	
	//angle[0] = 0.0;

	entity_set_origin( entid, origin );
	entity_set_vector( entid, EV_VEC_angles, angle );	
	
	
}

//Fix our view model and player model to show correct weapon.
public CurWeapon_FixViewModel(id) 
{
	new clip, ammo, weapon = get_user_weapon(id,clip,ammo);
	
	new holder = GetBallData( BALL_HOLDER );
	if(holder != id)
	{
		if(weapon == CSW_KNIFE)
			entity_set_string(id, EV_SZ_viewmodel, "models/v_bknuckles.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/p_bknuckles.mdl")
		return PLUGIN_HANDLED;	
	}
		
	
	if(weapon == CSW_HEGRENADE)
		entity_set_string(id,EV_SZ_viewmodel,"models/football/v_football.mdl");
	else if(weapon == CSW_KNIFE)
		entity_set_string(id, EV_SZ_viewmodel, "models/v_bknuckles.mdl");
			
	entity_set_string(id,EV_SZ_weaponmodel,"models/football/p_football.mdl");
	
	return PLUGIN_CONTINUE;
}

public EmitSound(id, channel, sample[])
{
	if(!is_user_alive(id) || !is_user_connected(id)) 
		return FMRES_IGNORED

	new temp[2], weapon = get_user_weapon(id, temp[0], temp[1])
	if(weapon == CSW_KNIFE)
	{
		if(equal(sample,"weapons/knife_hit1.wav")) 
		{
			emit_sound(id, CHAN_WEAPON, "bknuckles/knife_hit1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			return FMRES_SUPERCEDE
		}
		else if(equal(sample,"weapons/knife_hit2.wav")) 
		{
			emit_sound(id, CHAN_WEAPON, "bknuckles/knife_hit2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)	
			return FMRES_SUPERCEDE
		}
		else if(equal(sample,"weapons/knife_hit3.wav")) 
		{
			emit_sound(id, CHAN_WEAPON, "bknuckles/knife_hit3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)	
			return FMRES_SUPERCEDE
		}
		else if(equal(sample,"weapons/knife_hit4.wav")) 
		{
			emit_sound(id, CHAN_WEAPON, "bknuckles/knife_hit4.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			return FMRES_SUPERCEDE
		}
		else if(equal(sample,"weapons/knife_stab.wav")) 
		{
			emit_sound(id, CHAN_WEAPON, "bknuckles/knife_stab.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)	
			return FMRES_SUPERCEDE
		}
	}
	return FMRES_IGNORED
}
/*
public SetModel_FixWorldModel(ent, model[])
{
	if(equali(model,"models/w_hegrenade.mdl")) {
		entity_set_model(ent,"models/football/w_football2.mdl");
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}
*/
public Event_DeathMsg(id)
{
	//new victim = read_data(2)
	//if( !PlayerHasBall(victim) )
	set_msg_block( g_msgDeathMsg, BLOCK_ONCE );
}



public CorpseBlock()
{
	return PLUGIN_HANDLED;
}

// fire in the hole sound
public msg_sendaudio() 
{
	new string[32];
	get_msg_arg_string(2,string,31);

	// stop grenade throwing radio alerts
	if(equali(string,"%!MRAD_FIREINHOLE")) {
		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

// fire in the hole message AND weapon cannot be dropped message
public msg_textmsg() {

	new string[32];

	// "This weapon cannot be dropped"
	get_msg_arg_string(2,string,31);
	if(equali(string,"#Weapon_Cannot_Be_Dropped")) {
		return PLUGIN_HANDLED;
	}

	// some exception thingy
	if(str_to_num(string) > 0) {
		// if it's a radio message
		get_msg_arg_string(3,string,31);
		if(equali(string,"#Game_radio")) {
			// "Fire in the hole!"
			get_msg_arg_string(5,string,31);
			if(equali(string,"#Fire_in_the_hole")) {
				return PLUGIN_HANDLED;
			}
		}
	}

	return PLUGIN_CONTINUE;
}

//fix for an exploit.
public menuclass(id) {
	
	// They changed teams
	SetPlayerModel(id, 0xFF);
}

/*
GetPlayerModel(id)
{
	if(!is_user_connected(id))
		return 0;

	return get_pdata_int(id, 126, 5);
}
*/

SetPlayerModel(id, int)
{
	if(!is_user_connected(id))
		return;

	set_pdata_int(id, 126, int, 5);
}

public team_select(id, key) { 
	if (key==0 || key==1 || key==4) 
		if(join_team(id, key))
			return PLUGIN_HANDLED
	return PLUGIN_CONTINUE 
} 

public vgui_jointeamone(id)
{
	if(join_team(id, 0))
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE 
}

public vgui_jointeamfive(id)
{
	if(join_team(id, 4))
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE 
}

public vgui_jointeamtwo(id)
{
	if(join_team(id, 1))
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE 
}
/*
public team_select_vgui(id) {
	if(join_team(id))
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE 
}
*/
bool:join_team(id, key=-1) 
{
	
	new team = get_user_team(id)
	
	if( (team == 1 || team == 2) && (key == team-1) )
	{		
		client_print(id, print_chat, "You cannot rejoin the same team!") 

		engclient_cmd(id,"chooseteam")
		return true
	}
	
	ClearPlayer(id);
	//if(key == 4)
	//	g_iPlayerTeam[id] = (team == 1) ? 2 : 1;
	//else
	//	g_iPlayerTeam[id] = key+1;
		
	ToggleDeath( id, 0 );
	return false;
}