
Handle_Effects()
{
	new flytype = GetBallData( BALL_FLY );
	new holder = GetBallData( BALL_HOLDER );
	new Float:gametime = get_gametime();
	
	//Ball above head effect
	if((flytype == FLY_NONE || flytype == FLY_HANDOFF))// && !g_bTournamentMode)
	{
		if(g_flFootballTEdelay <= gametime )
		{
			FX_Football( holder );
			g_flFootballTEdelay = gametime + 0.5;
		}
	}
	
	//Prediction Effect (Wave)
	if(g_bLandEffect)
	{
		if(g_flLandEffectDelay < gametime)
		{
			FX_Wave(g_vLandOrig);
			g_flLandEffectDelay = gametime + PULSE_FREQUENCY;
		}	
	}	
}

public LinePaint()
{
	if(!g_bPaintLine)
		return;
		
	if(g_iPlay == PLAY_KICKOFF)//;// || g_iGameMode == GAME_EXTRA)
		return;
		
	new Float:yOrig;
	new istart[3], iend[3];
	
	yOrig = GetOriginYard( g_flCurrentYard );
	
	//Line of scrimmage (BLUE).
	g_vSideLine[1][1] = yOrig;
	g_vSideLine[2][1] = yOrig;
	
	FVecIVec(g_vSideLine[1], istart);
	FVecIVec(g_vSideLine[2], iend);
	iend[2] += 2;
	istart[2] += 2;
	FX_Beam( istart, iend, { 0, 0, 255, 255 }, 30 );
	
	yOrig = GetOriginYard( g_flTargetYard );
	
	//First Down line (YELLOW)
	// Turn it (RED) if our First Down is the goal line.
	new green = 255;
	if(g_flTargetYard == 100.0)
		green = 0;
		
	g_vSideLine[1][1] = yOrig;
	g_vSideLine[2][1] = yOrig;
	FVecIVec(g_vSideLine[1], istart);
	FVecIVec(g_vSideLine[2], iend);
	new color[4];
	color[0] = 255; color[1] = green, color[2] = 0, color[3] = 255;
	iend[2] += 2;
	istart[2] += 2;
	FX_Beam( istart, iend, color, 30 );
}

/*
// Status: 0 nothing, 1 dead, 2 bomb
FX_Status( id, status )
{
	message_begin( MSG_ALL, g_msgScoreAttrib, _, 0);
	write_byte(id);
	write_byte(status);
	message_end();
}
*/

FX_DeathMsg( attacker, victim, const weapon[] )
{
	message_begin(MSG_BROADCAST, g_msgDeathMsg);
	write_byte(attacker);
	write_byte(victim);
	write_string(weapon);
	message_end();
}
	
FX_Football( id )
{
	FX_Overhead( id, g_fxFootball, 45, 6 );
}
/*
FX_ResetHud( id )
{
	message_begin( MSG_BROADCAST, g_msgResetHud, _, id );	
	message_end();
}
*/
FX_GameTime( gametime )
{
	message_begin(MSG_BROADCAST, g_msgRoundTime);
	write_short( gametime );
	message_end();	
}

FX_StatusIcon( num, bool:off=false )
{
	static lastNum = -1;
	
	if(num > 9)
		num = 9;
	new number[10];
	format(number, 9, "number_%i", num );
	
	if(off)
	{
		message_begin(MSG_BROADCAST, g_msgStatusIcon, _, 0)
		write_byte(0)				// status
		write_string(number)	// sprite name
		write_byte(0)				// red
		write_byte(0)				// green
		write_byte(0);				// blue
		message_end();
		return;
	}
	
	if(lastNum == num && num != 9)
		return;
		
	if(lastNum != -1 && lastNum != num)
		FX_StatusIcon( lastNum, true );
	
	lastNum = num;
	new status = 1;
	
	if(num <= 3)
		status = 2;
	
	message_begin(MSG_BROADCAST, g_msgStatusIcon, _, 0)
	write_byte(status)				// status
	write_string(number)			// sprite name
	write_byte(0)					// red
	write_byte(255)				// green
	write_byte(0);					// blue
	message_end();
}

FX_Overhead( target, sprite, zOffset, lifetime )
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_PLAYERATTACHMENT);
	write_byte(target);
	write_coord(zOffset); //(attachment origin.z = player origin.z + vertical offset)
	write_short(sprite);
	write_short(lifetime);
	message_end();
}

FX_Wave( origin[3] ) 
{
	new freq = floatround(PULSE_FREQUENCY * 10.0)
	
	//wave
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	//message_begin(MSG_ONE,SVC_TEMPENTITY)
	write_byte( 21 ) 
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2] + 5)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2] + 100)
	write_short( g_fxWave )
	write_byte( 0 ) 		// startframe 
	write_byte( 0 ) 		// framerate 
	write_byte(freq) 		// life 2
	write_byte( 20 ) 		// width 16 
	write_byte( 20 ) 		// noise 
	write_byte( WAVE_COLOR_RED ) 	// r 
	write_byte( WAVE_COLOR_GREEN ) 	// g 
	write_byte( WAVE_COLOR_BLUE ) 	// b 
	write_byte( 255 ) 		//brightness 
	write_byte( 5 / 10 ) 	// speed 
	message_end() 
	
}

FX_Trail( entity, type=1 )
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(22); 		// TE_BEAMFOLLOW
	write_short(entity); 	// ball
	write_short(g_fxBeam); 	// laserbeam
	if(type==1)
	{
		write_byte(4); 			// life
		write_byte(5); 			// width
		write_byte(255); 		// R
		write_byte(255); 		// G
		write_byte(255); 		// B
		write_byte(100); 		// brightness
	}
	else if(type==2)
	{
		write_byte(3); 			// life
		write_byte(2); 			// width
		write_byte(220); 			// R
		write_byte(167); 		// G
		write_byte(95); 		// B
		write_byte(50); 		// brightness
	}
	else if(type==3)
	{
		write_byte(3); 			// life
		write_byte(7); 			// width
		write_byte(255); 			// R
		write_byte(255); 		// G
		write_byte(0); 		// B
		write_byte(30); 		// brightness
	}
	message_end();	
}

FX_Beam( origin1[3], origin2[3], color[4],width=40 )
{
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte(TE_BEAMPOINTS)
	write_coord(origin1[0])		//origin 1
	write_coord(origin1[1])
	write_coord(origin1[2])
	write_coord(origin2[0])		//origin 2
	write_coord(origin2[1])
	write_coord(origin2[2])		
	write_short(g_fxBeamSprite)	//sprite index 
	write_byte(0) 				//start frame
	write_byte(1) 				//framerate
	write_byte(20)				//life
	write_byte(width) 				//width
	write_byte(0) 				//noise
	write_byte(color[0]) 		//red
	write_byte(color[1])		//green
	write_byte(color[2])		//blue
	write_byte(color[3])		//alpha
	write_byte( 10 )			//scroll speed
	message_end()
}