

//-------Plugin essentials-------
new bool:g_bPluginOn;
new g_iMaxplayers;

//-------Player Data-------
new bool:Ready[MAX_PLAYERS];
new g_iButtons[MAX_PLAYERS];
new g_iWeapon[MAX_PLAYERS];

//-------Vote Data-------
new g_iTouchdownVote;
new g_iFourthVote;

//-------Football Data-------
new g_iLastEvent;

new g_iFirstKickoffTeam;

new Float:g_flFootballTossTime; //Delay before player who threw/kicked can pick up ball.

//new g_iLastPlay;
//new g_iNextPlay;
new g_iHutCount;
new g_iCatchFlytype;

new Float:g_flStartYard[TEAMS];
new bool:g_bPlayClockOn;
new g_iPlayClock;

new bool:g_bTouchedPlayer;
new bool:g_bTouchedGround;
new bool:g_bTouchedBack;
new bool:g_bExtraPoint;

new g_iBounds[MAX_PLAYERS]; //Player in bound or out of bound?
new g_iScore[TEAMS];
new bool:g_bPassedScrimmage;

new g_iCountdownTimer; //Football game start timer
new Float:g_flGameTimer;
new bool:g_bGameStart;
new bool:g_bGameTimerON;
new g_iGameMode;
new g_iQuarter;
new g_iPlay;
new g_iDown;
new Float:g_flCurrentYard;
new Float:g_flTargetYard;

//-------Ball Data-------
new g_iBallData[BALL_COUNT];
new Float:g_vecBall[3];
new Float:g_flCurrentBallYard;

/*
//-------Ham Module Hooks -----
new HamHook:HAM_PRIMARY_ATTACK;
new HamHook:HAM_SECONDARY_ATTACK;
*/

//-------CVAR Pointers-------
new P_GAMETIME;
new P_COUNTDOWNTIME;
new P_PLAYERS;
new P_VOTETIME;
new P_SAFETYDIVE;
new P_RUNNINGBACK;

//-------Predicted Landing-------
new g_vLandOrig[3];
new bool:g_bLandEffect;
new Float:g_flLandEffectDelay;


//-------Msg Forwards-------
//new g_msgResetHud;
new g_msgRoundTime;
new g_msgSayText;
new g_msgDeathMsg;
//new g_msgScoreAttrib;
//new g_msgScoreboard;
new g_msgStatusIcon;
new g_msgCorpse;

//-------Forward Handles-------
//new FORWARD_BEGIN_PLAY;
//new FORWARD_TOURNAMENTMODE;

//-------FX - Sprite/Models-------
new g_fxWave;
new g_fxFootball;
new g_fxBeam;


//-------Misc.-------
new Float:g_flFootballTEdelay;



//-------Map Data--------

//X and Y values of each formation and class
new Float:ClassOriginX[FORMATION_COUNT][SPAWN_POSITIONS][MAX_SPAWNS];
new Float:ClassOriginY[FORMATION_COUNT][SPAWN_POSITIONS][MAX_SPAWNS];

new Reserved[FORMATION_COUNT][SPAWN_POSITIONS][MAX_SPAWNS]; //Current Spawn is reserved.
new Count[FORMATION_COUNT][SPAWN_POSITIONS]; 				//Total Spawn count for each formation and class
new Float:g_flBallYOrig[2][3]; 						//Field Goal and Kickoff ball positions


//-------Entity variables-------
new Float:g_vGoalLine[TEAMS];//Team Touchdown goal line Y value
new Float:g_flYardDist;	     //Size in units per yard for the current map
new Float:g_vSideLine[3][3]; //0 = absolute center field, 1 and 2 are side lines

new g_iGoalZone[TEAMS];		//Team Goal zone entity ids
new g_iFieldGoal[TEAMS];	//Team Fieldgoal entity ids

new g_HudMsg1[MAX_PLAYERS+1][128];
new g_HudMsg2[1024];
new g_HudMsg3[128];
new g_HudMsg4[64];

new Float:g_MsgTime;
new bool:g_bPaintLine;


/*
new TeamNames[TEAMS][] = {
	"Unassigned",
	"Terr",
	"CT"
}
*/

new P_PLAYERSNEEDED;
new g_iTouchdownItems[2];
new g_iFourthItems[3];
new g_iVoteCount;

new bool:g_bTournamentMode;

//new Float:g_flTurboDelay[MAX_PLAYERS];
//new g_iSprint[MAX_PLAYERS];
new g_fxBeamSprite;
//new g_fxPowerUp;
//new g_fxFire;

//-------------------------------------------------------------------
//fb_class.sma
new HELP_MOTD_FILE[] = "football/help.html"

new g_IsFirstSpawn[MAX_PLAYERS];
new g_iPlayerTeam[MAX_PLAYERS];


enum
{
	__QUARTERBACK = 0,
	__SAFETY,
	__KICKER,
	__SPECIAL_COUNT	
}

//Controls players class and special sign ups.
new g_iClass[MAX_PLAYERS];
new g_iSpecialSignup[MAX_PLAYERS];

//Controls current special class for play and special players for each class.
new g_iSpecialClass[TEAMS];
new g_iSpecial[TEAMS][CLASS_COUNT];

//Controls our special list to rotate players.
new g_iSpecialList[TEAMS][CLASS_COUNT][MAX_PLAYERS];
new g_iSpecialListCnt[TEAMS][CLASS_COUNT];
new g_iSpecialListPos[TEAMS][CLASS_COUNT];
//new g_iSpecialRoster[TEAMS][__SPECIAL_COUNT][MAX_PLAYERS];
//new g_iRosterCount[TEAMS][__SPECIAL_COUNT];
//new g_iCurrentSpecial[TEAMS][__SPECIAL_COUNT];

//Holds players currently as special class
//new g_iSpecialTeam[TEAMS][CLASS_COUNT];

//Current player class.
//new g_iPlayerClass[MAX_PLAYERS];
//new g_iPlayerCurrentClass[MAX_PLAYERS];

//new g_iClassCount[TEAMS][CLASS_COUNT+1]; //Total count of each class.

//Skips player for this class on their alternate round.
//new g_bSkip[MAX_PLAYERS][CLASS_COUNT];


//Max amount of players per class.
new g_iMaxClassCount[CLASS_BENCH+1] = 
{
	0, //None
	4, //WideReceivers
	2, //RunningBack
	//2, //LineBacker
	5, //LineMan
	1, //Coach
	2  //Bench
}



//#define TOURNAMENT_PLAYERS 5
//new g_iPlayerTournmanet[TEAMS][TOURNAMENT_PLAYERS];

new g_szSuffix[5][] = { "", "st", "nd", "rd", "th" }
new g_szOffense[CLASS_BENCH+1][] = { "None", "Wide Receiver", "Running Back",  "Offensive Lineman", "Coach", "Bench" }
new g_szDefense[CLASS_BENCH+1][] = { "None", "Corner Back", "Line Backer", "Defensive Lineman", "Coach", "Bench" }
new g_szSpecial[CLASS_BENCH+1][] = { "Quarterback", "Safety", "Kicker", "Running Back", "", "" }

new g_iClassMenu;
new g_iSpecialMenu;
//new g_iTournamentClass;

new bool:g_iChoosingClass[MAX_PLAYERS];



//-------------------------------------------------------------------
//new g_iPlayerCamera[MAX_PLAYERS];
new bool:g_bActivateAttack[MAX_PLAYERS];


//new bool:g_bCanKill;

//new g_fmPlayerPreThink;
//new g_fmPlayerPreThink_Post;
new Float:g_vecVel[MAX_PLAYERS][3];
new bool:g_bRestoreVel[MAX_PLAYERS];



new bool:g_bPlayerFrozen[MAX_PLAYERS];
new Float:g_vPlayerPos[MAX_PLAYERS][3];
new bool:g_bPlayerDied[MAX_PLAYERS];

/*
new g_szPlay[PLAY_COUNT][] =
{
	"NONE",
	"STANDARD",
	"FIELDGOAL",
	"PUNT",
	"KICKOFF"
}
*/

new g_szStatNames[S_TOTAL_COUNT][] = 
{
	"S_PASS_ATTEMPT",
	"S_PASS_COMPLETE",
	"S_PASS_YARDS",
	"S_PASS_FIRSTDOWN",
	"S_PASS_INTERCEPT",
	"S_PASS_FUMBLE",
	"S_PASS_FUMBLE_RECOVER",	
	"S_PASS_SACK",
	"S_PASS_SACK_YARDS",
	"S_PASS_LONG",
	"S_PASS_LONG_TD",
	"S_PASS_TD",
	
	"S_RECV_RECEIVES",
	"S_RECV_YARDS",
	"S_RECV_FIRSTDOWN",
	"S_RECV_LONG",
	"S_RECV_LONG_TD",
	"S_RECV_TD",
	
	"S_RUSH_ATTEMPT",
	"S_RUSH_YARDS",
	"S_RUSH_FIRSTDOWN",
	"S_RUSH_LONG",
	"S_RUSH_LONG_TD",
	"S_RUSH_TD",
	
	"S_LINEMAN_SACK_ALLOWED",
	"S_LINEMAN_BLOCK",
	"S_LINEMAN_PANCAKE",
	
	"S_DEF_SACK",
	"S_DEF_SACKASSIST",
	"S_DEF_TACKLE",
	"S_DEF_TACKLE_ASSIST",
	"S_DEF_FUMBLE_FORCE",
	"S_DEF_FG_BLOCK",
	"S_DEF_PUNT_BLOCK",
	
	"S_FUMBLE",			
	"S_FUMBLE_RECOVER",
	
	"S_TURNOVER",
	"S_TURNOVER_YARDS",		
	"S_TURNOVER_TD",			
	"S_TURNOVER_LONG",		
	"S_TURNOVER_LONG_TD",		
	
	"S_INT",
	"S_INT_YARDS",
	"S_INT_TD",
	"S_INT_LONG",
	"S_INT_LONG_TD",
	
	"S_RETURN_PUNT",
	"S_RETURN_PUNT_YARDS",
	"S_RETURN_PUNT_TD",
	"S_RETURN_PUNT_LONG",
	"S_RETURN_PUNT_LONG_TD",
	
	"S_RETURN_KICK",
	"S_RETURN_KICK_YARDS",
	"S_RETURN_KICK_TD",
	"S_RETURN_KICK_LONG",
	"S_RETURN_KICK_LONG_TD",
	
	"S_PUNT_ATTEMPT",
	"S_PUNT_YARDS",
	"S_PUNT_OUTOFBOUND",
	"S_PUNT_TOUCHBACK",
	"S_PUNT_IN20",
	"S_PUNT_BLOCK",
	"S_PUNT_LONG",
	
	"S_FG_ATTEMPT_0",
	"S_FG_MADE_0",
	"S_FG_ATTEMPT_20",
	"S_FG_MADE_20",
	"S_FG_ATTEMPT_30",
	"S_FG_MADE_30",
	"S_FG_ATTEMPT_40",
	"S_FG_MADE_40",
	"S_FG_ATTEMPT_50",
	"S_FG_MADE_50",
	"S_FG_YARDS",
	"S_FG_LONG",
	"S_FG_BLOCK",
	
	"S_KICK_ATTEMPT",
	"S_KICK_OUTOFBOUND",
	"S_KICK_TOUCHBACK",
	"S_KICK_ONSIDE_ATTEMPT",
	"S_KICK_ONSIDE_RECOVERED",
	"S_KICK_RETURN",
	"S_KICK_RETURN_TD",
	"S_KICK_RETURN_YARDS"
}

/*
new g_szRefereeCall[REFEREE_COUNT][] = 
{
	//EVENTS
	"NONE",
	"DOWN",//DOWN = 1,		//Down at yard
	"TOUCHBACK",
	"OUTOFBOUNDS", 	//Ran out of bounds
	"TWOMINUTE",		//two minute warning
	"GAME_START",
	"GAME_END_QUARTER",		//End of game
	
	
	//Scoring Events
	"SCORE_EVENT",
	"SCORE_FIELDGOAL",	//3 Points
	"SCORE_TOUCHDOWN",	//6 points
	"SCORE_EXTRAPOINT",	//1 point
	"SCORE_TWOPOINT",		//2 points
	"SCORE_SAFETY",		//2 points
	
	
	//Failed Events
	"FAIL_EVENT",			//Referenced for coders
	"FAIL_FOURTH",		//Failed 4th down
	"FAIL_FIELDGOAL",		//Failed 3 pt FG attempt
	"FAIL_EXTRAPOINT",	//Failed extra pt FG
	"FAIL_TWOPOINT",		//Failed extra pt 2 pt conversion
	
	"FG_NOGOOD",
	
	//Kick failures
	"KICK_EVENT",			//Referenced for coders
	"KICK_NEGATIVEYARD",	//Kicked in the opposite direction
	"KICK_SHORT",			//Touched less than X yards from kicking yard.
	"KICK_OUTOFBOUNDS",	//Kick landed out of bounds.
	"KICK_TOUCHBACK",		//Team kneeled/ran out in endzone
	"KICK_ROLLED_OUT",	//Ball rolled out of bounds
	//KICK_ROLLED_OUT_20,
	
	//Punt failures
	"PUNT_EVENT",			//Referenced for coders
	"PUNT_NEGATIVEYARD",  //Kicked opposite direction
	"PUNT_RETURNTOUCH",	//Return team touched ball
	"PUNT_OUTOFBOUNDS",	//Ball landed out of bounds
	"PUNT_TOUCHBACK",		//Ball landed out of bounds at endzone. (several ways for this to happen)
	"PUNT_ROLLED_OUT",	//Ball rolled out of bounds
	
	//Pass failures
	"PASS_CATCH_OUTOFBOUNDS",	//Pass caught out of bounds
	"PASS_INCOMPLETE",		//Pass missed by all.
	"PASS_OUTOFBOUNDS",		//Pass landed out of bounds.

	//Penalties
	"PENALTY_EVENT",
	"PENALTY_DELAYOFGAME",	//Team took to long to snap ball.
	"PENALTY_PASSINT",		//defense knifed receiver with ball in air headed his way
	"PENALTY_OFFSIDES"		//Player on wrong side of scrimmage after 2nd hut
		
}
*/


//---------------------------------------------------//
// ABILITY GLOBALS ----------------------------------//
//---------------------------------------------------//
#define _STR  	0
#define _DEX	1
#define _AGI	2
#define _WEIGHT 3
	
new Float:g_flStamina[MAX_PLAYERS]; 				//Total Stamina player has to use abilities on
//new Float:g_flStrength[MAX_PLAYERS]; 				//Total Strength player uses for his abilities.
new g_iAbility[MAX_PLAYERS]; 						//Active abilities
new Float:g_flAbilityDelay[MAX_PLAYERS][A_COUNT]; 	//Time keeper for abilities
new Float:g_flAbilityTeamAgi[TEAMS]; 		//Gives the entire team a bonus for the ability


new Float:g_flAbilityStats[CLASS_COUNT][_WEIGHT+1] =
{
	//BALL HOLDER (except QB)
	{ HOLDER_STR, HOLDER_DEX, HOLDER_AGI, HOLDER_WEIGHT },	
	//Receiver
	{ RECEIVER_STR, RECEIVER_DEX, RECEIVER_AGI, RECEIVER_WEIGHT },
	//Running back
	{ RUNNINGBACK_STR, RUNNINGBACK_DEX, RUNNINGBACK_AGI, RUNNINGBACK_WEIGHT },	
	//Line backer
	{ LINEBACKER_STR, LINEBACKER_DEX, LINEBACKER_AGI, LINEBACKER_WEIGHT },	
	//Lineman
	//{ LINEMAN_STR, LINEMAN_DEX, LINEMAN_AGI, LINEMAN_WEIGHT },	
	//Coach
	{ 0.0, 0.0, 0.0, 0.0 },
	//Bench
	{ 0.0, 0.0, 0.0, 0.0 },
	//Quarterback
	{ QUARTERBACK_STR, QUARTERBACK_DEX, QUARTERBACK_AGI, QUARTERBACK_WEIGHT },	
	//Safety
	{ SAFETY_STR, SAFETY_DEX, SAFETY_AGI, SAFETY_WEIGHT },	
	//Kicker
	{ HOLDER_STR, KICKER_DEX, KICKER_AGI, KICKER_WEIGHT }	
}

//Price in Stamina.  Player starts with 100.0
new Float:g_flAbilityPrice[A_COUNT] =
{
	0.0,				
	PRICE_TURBO_QUICK,	
	PRICE_TURBO_LONG,	
	PRICE_OLDDIVE,
	PRICE_DIVE,			
	PRICE_JUMP,			
	PRICE_TACKLE,		
	PRICE_STIFFARM,		
	PRICE_THROW,		
	PRICE_TACKLED			
}

/*
new Float:g_flAbilityCooldown[A_COUNT] =
{
	0.0,
	DELAY_TURBO_QUICK,
	DELAY_TURBO_LONG,
	0.0,
	DELAY_DIVE,
	0.0, 0.0, 0.0, 0.0,
	DELAY_TACKLED
}
*/