
static const g_szSpawnNames[FORMATION_COUNT][] = 
{ 
	"fb_info_offense", 
	"fb_info_defense", 
	"fb_info_receive", 
	"fb_info_return", 
	"fb_info_punt",
	"fb_info_puntreturn",
	"fb_info_fieldgoal",
	"fb_info_fieldgoalblock" 
}

//-----------------------------
// KEYVALUES
//-----------------------------
public pfn_keyvalue(entid) {
	
	new classname[32], key[32], value[32]
	copy_keyvalue(classname, 31, key, 31, value, 31)

	new temp_origins[3][10];
	static type = 0;
	static playerEquip = 0;
	static bool:RunOnce = false;
	
	if(!RunOnce)
	{
		playerEquip = create_entity("game_player_equip");
		if(playerEquip) {
			//DispatchKeyValue(playerEquip, "weapon_knife", "1");
			//DispatchKeyValue(entity, "weapon_scout", "1");
			DispatchKeyValue(playerEquip, "targetname", "roundstart");
			DispatchSpawn(playerEquip);
		}
		RunOnce = true;	
	}
	
	//We don't need this so remove it if theres one.
	if(playerEquip != entid && equali(classname, "game_player_equip"))
		remove_entity(entid);
	
		
	//Brush entities with custom names, need to be converted to trigger_multiples to work properly.
	if(equal(key, "classname"))
	{
		if(equal(value, "fb_inbounds"))
		{
			DispatchKeyValue("classname", "trigger_multiple");
			type = 1;//entity_set_int( entid, EV_INT_iuser3, 1 );
		}
		else if(equal(value, "fb_outofbounds"))
		{
			DispatchKeyValue("classname", "trigger_multiple");
			type = 2;//entity_set_int( entid, EV_INT_iuser3, 2 );
		}
		else if(equal(value, "fb_func_teamgoal" ))
		{
			DispatchKeyValue("classname", "trigger_multiple");
			type = 3;	
		}
		else if(equal(value, "fb_func_teamfieldgoal" ))
		{
			DispatchKeyValue("classname", "trigger_multiple");
			type = 4;	
			
		}
	}
		
	if(equal(classname, "trigger_multiple"))
	{
		if(type == 1)
			set_task(1.0, "FinalizeInBound", entid)
		else if(type == 2)
			set_task(1.0, "FinalizeOutOfBound", entid );
		else if(type == 3)
		{
			if(equali(key, "team"))
			{
				new team = str_to_num(value);
				if(team == 1 || team == 2)
				{
					g_iGoalZone[team] = entid
					set_task(1.0, "FinalizeGoal", team+TASK_FINAL_GOAL)
					type = 0;
				}
			}
		}	
		else if(type == 4)
		{
			if(equali(key, "team"))
			{
				new team = str_to_num(value);
				if(team == 1 || team == 2)
				{
					g_iFieldGoal[team] = entid;
					set_task(1.0, "FinalizeFieldGoal", team+TASK_FINAL_FG);
					type = 0;	
				}	
			}	
		}
			
		if(type != 3 && type != 4)
			type = 0;
	}
	
	//Parse out the Y origins of these entities to calculate yardage
	if(equali(classname, "fb_teamone"))
	{
		if(equal(key, "origin"))
		{
			parse(value, temp_origins[0], 9, temp_origins[1], 9, temp_origins[2], 9);
			g_vGoalLine[T] = floatstr(temp_origins[1]);
		}	
	}
	else if(equali(classname, "fb_teamtwo"))
	{
		if(equal(key, "origin"))
		{
			parse(value, temp_origins[0], 9, temp_origins[1], 9, temp_origins[2], 9);
			g_vGoalLine[CT] = floatstr(temp_origins[1]);
		}	
	}
	else if(equali(classname, "fb_center")) 
	{
		if(!g_bPluginOn)
			g_bPluginOn = true;
			
		if(equal(key, "origin"))
		{
			parse(value, temp_origins[0], 9, temp_origins[1], 9, temp_origins[2], 9);
			g_vSideLine[0][0] = floatstr(temp_origins[0]);
			g_vSideLine[0][1] = floatstr(temp_origins[1]);
			g_vSideLine[0][2] = floatstr(temp_origins[2]);
		}	
	}
	
	static Float:yValue = 0.0;
	static Float:xValue = 0.0;
	new i, num;
	new cnt;
	
	for(i=0;i<FORMATION_COUNT;i++)
	{
		if(equali(classname, g_szSpawnNames[i]))
		{
			//In theory after getting origin, the position key should come up next pass.
			if(equali(key, "origin"))
			{
				parse(value, temp_origins[0], 9, temp_origins[1], 9, temp_origins[2], 9);
				xValue = floatstr( temp_origins[0] );
				yValue = floatstr( temp_origins[1] );
			}
			else if(equali(key, "position"))
			{
				
				num = str_to_num(value);
				if(num == -2)
				{
					num = KICKOFF_BALLPOS;
					
					if(equali(classname, "fb_info_fieldgoal"))
						num = FIELDGOAL_BALLPOS;
						
					g_flBallYOrig[ num ][ 0 ] = xValue;
					g_flBallYOrig[ num ][ 1 ] = yValue;
				}
				else
				{
					if(num == -1)
						num = 0;
						
					cnt = Count[ i ][ num ];
					
					if(equali(classname, "fb_info_offense") && (num == 0 || num == CLASS_RUNNINGBACK))
					{
						yValue -= 100.0;	
					}
					ClassOriginX[ i ][ num ][ cnt ] = xValue;
					ClassOriginY[ i ][ num ][ cnt ] = yValue;
					
					Count[ i ][ num ]++;
				}
				//server_print( "%s = %i", g_szSpawnNames[i] , num );
			}	
			break;
		}
	}
}

public FinalizeFieldGoal(team)
{
	team -= 2000;
	new entid = g_iFieldGoal[team];
	
	entity_set_string(entid, EV_SZ_classname,"fb_func_teamfieldgoal");
	set_entity_visibility( entid, 0);
	
	entity_set_int( entid, EV_INT_team, team );	
}

public FinalizeGoal(team)
{
	team -= 1000;
	new entid = g_iGoalZone[team];
	
	entity_set_string(entid, EV_SZ_classname,"fb_func_teamgoal");
	set_entity_visibility( entid, 0);
	
	entity_set_int( entid, EV_INT_team, team );	
}

public FinalizeInBound(entid) 
{
	entity_set_string(entid, EV_SZ_classname,"fb_inbounds");
	set_entity_visibility( entid, 0);
}

public FinalizeOutOfBound(entid) 
{
	entity_set_string(entid, EV_SZ_classname,"fb_outofbounds");
	set_entity_visibility( entid, 0);
}

Map_SetYardSize()
{
	g_flYardDist = (g_vGoalLine[CT] - g_vGoalLine[T]) / 100.0;
	if(g_flYardDist < 0)
		g_flYardDist = -(g_flYardDist);	
}

Map_SetSideLines()
{
	//Trace downward to find floor origin.
	new Float:start[3], Float:end[3], Float:ret[3];
	
	start[0] = g_vSideLine[0][0];
	start[1] = g_vSideLine[0][1];
	start[2] = g_vSideLine[0][2] + 100;
	
	end[0] = g_vSideLine[0][0];
	end[1] = g_vSideLine[0][1];
	end[2] = g_vSideLine[0][2] - 100;
	
	engfunc(EngFunc_TraceLine, start, end,  1, -1, 0);

	get_tr2(0, TR_vecEndPos, ret)
	
	g_vSideLine[0][2] = ret[2] + 1.0;
	
	//Trace sideways both ways to find the side lines (fb_outofbounds)
	new Float:dir[3];
	dir[0] = g_vSideLine[0][0] + 1320.0;
	dir[1] = g_vSideLine[0][1];
	dir[2] = g_vSideLine[0][2];
	
	trace_line(-1, g_vSideLine[0], dir, g_vSideLine[1]);
	dir[0] = g_vSideLine[0][0] - 1320.0;
	trace_line(-1, g_vSideLine[0], dir, g_vSideLine[2]);
}

//This sorts our formations by closest to center (x=0)
//This needs to order by X and then by Y in between same X values
Map_SortSpawns()
{
	/*
	new formation, class, count, pos;
	new Float:upper[MAX_SPAWNS][2];
	new Float:lower[MAX_SPAWNS][2];
	new upperCnt, lowerCnt;
	formation = KRETURN;
	
	new Float:origins[MAX_SPAWNS][2];
	new total, lowerPos;
	
	//Move our players to the front line on kickoff return formation, except for RB and safety.
	for(class=CLASS_RECEIVER;class<=CLASS_LINEMAN;class++)
	{
		if(class == CLASS_RUNNINGBACK)
			continue;
			
		count = Count[formation][class];
		upperCnt = 0;
		lowerCnt = 0;
		
		for(pos=0;pos<count;pos++)
		{
			if(ClassOriginY[formation][class][pos] < 500.0)
			{

				upper[upperCnt][0] = ClassOriginX[formation][class][pos];
				upper[upperCnt++][1] = ClassOriginY[formation][class][pos];
			}	
			else
			{
				lower[lowerCnt][0] = ClassOriginX[formation][class][pos];
				lower[lowerCnt++][1] = ClassOriginY[formation][class][pos];
			}
		}
		
		total = (upperCnt+lowerCnt)-1;
		for(pos=0;pos<=total;pos++)
		{
			if(pos<upperCnt)
			{
				ClassOriginX[formation][class][pos] = upper[pos][0];
				ClassOriginY[formation][class][pos] = upper[pos][1];	
			}
			else
			{
				lowerPos = pos-upperCnt;
				ClassOriginX[formation][class][pos] = lower[lowerPos][0];
				ClassOriginY[formation][class][pos] = lower[lowerPos][1];
			}
			
			server_print( "Class = %i   OriginX = %f", class, ClassOriginX[formation][class][pos] );
		}
	}
	
	
	//Move our RB positions for OFFENSE formation to the center.
	formation = OFFENSE;
	class = CLASS_RUNNINGBACK;
	count = Count[formation][class];
	
	new Float:firstSpawn[2];
	new posTotal;
	new bool:isTaken[MAX_SPAWNS];
	
	//copy all positions.
	for(pos=0;pos<count;pos++)
	{
		upper[pos][0] = ClassOriginX[formation][class][pos];
		upper[pos][1] = ClassOriginY[formation][class][pos];
		
	}
	//sort starting from largest X value.
	for(total=0;total<count;total++)
	{
		for(pos=0;pos<count;pos++)
		{
			if( !isTaken[pos] && upper[pos][0] > lower[total][0] )
			{
				lower[total][0] = ClassOriginX[formation][class][pos];
				lower[total][1] = ClassOriginY[formation][class][pos];
				
				isTaken[pos] = true;
			}		
		}	
	}
	//copy back to originals in reverse.
	for(pos=count-1;pos>=0;pos--)
	{
		ClassOriginX[formation][class][pos] = lower[pos][0];
		ClassOriginY[formation][class][pos] = lower[pos][1];
	}

		*/
	



	new Float:negative[10][2];
	new Float:positive[10][2];
	new x, a, negCount, posCount;
	new formation, class, count;
	new Float:origins[2];
	
	//new Float:orig[10][2];
	new tempCount, tempNegCount, Float:temp[2];
	for(formation=0;formation<FORMATION_COUNT;formation++)
	{
		//server_print( "----------------------");
		//server_print( "Formation = %s", g_szSpawnNames[formation] );
		
		for(class=0;class<SPAWN_POSITIONS;class++)
		{
			//if(class == CLASS_RUNNINGBACK || class == CLASS_RECEIVER || class == CLASS_LINEMAN)
			//	server_print( "Class = %i", class );
			posCount = 0; 
			negCount = 0;
			count = Count[formation][class];
			
			//Split up our negative and positive X positions
			for(x=0;x<count;x++)
			{
				origins[0] = ClassOriginX[formation][class][x];
				origins[1] = ClassOriginY[formation][class][x];
				
				if(origins[0] > 0.0) 
				{
					//if(class == CLASS_RUNNINGBACK || class == CLASS_RECEIVER || class == CLASS_LINEMAN)
					//	server_print( "BEFORE Origin ( %f, %f )", origins[0], origins[1] );
					positive[posCount][0] = origins[0];
					positive[posCount++][1] = origins[1];
				}
				else 
				{
					negative[negCount][0] = origins[0];
					negative[negCount++][1] = origins[1];
				}
			}
			
			//CREDITS TO MathBits.com for this neat sorting algorithm
			//Exchange sort our Positive values in Ascending order
			for (x=0; x< (posCount-1); x++)    // to represent element to be compared
		    {
				for(a = x+1; a < posCount; a++)   // to represent the rest of the elements
				{
					if (positive[x][0] > positive[a][0])
					{
						//if(class == CLASS_RUNNINGBACK || class == CLASS_RECEIVER || class == CLASS_LINEMAN)
						//	server_print( "BETWEEN - Swapping %i with %i", x, a );
						temp[0] = positive[x][0];          // swap
						temp[1] = positive[x][1];          // swap
						
						positive[x][0] = positive[a][0];
						positive[x][1] = positive[a][1];
						
						positive[a][0] = temp[0];
						positive[a][1] = temp[1];
					}
				}
			}
			
			//Exchange sort our Negative Values in Descending order
			for (x=0; x< (negCount-1); x++)    // to represent element to be compared
		    {
				for(a = x+1; a < negCount; a++)   // to represent the rest of the elements
				{
					if (negative[x][0] < negative[a][0])
					{
						temp[0] = negative[x][0];          // swap
						temp[1] = negative[x][1];          // swap
						
						negative[x][0] = negative[a][0];
						negative[x][1] = negative[a][1];
						
						negative[a][0] = temp[0];
						negative[a][1] = temp[1];
					}
				}
			}
     
			negCount -= 1; posCount -= 1;
			count = Count[formation][class];
			tempCount = 0;
			tempNegCount = 0;
			x = 0;
			while( x < count )
			{
				if(tempNegCount <= negCount)
				{
					//if(class == CLASS_RECEIVER || class == CLASS_LINEMAN)
					//server_print( "AFTER Origin ( %f, %f )", negative[tempNegCount][0], negative[tempNegCount][1] );
					ClassOriginX[formation][class][x] = negative[tempNegCount][0];
					ClassOriginY[formation][class][x++] = negative[tempNegCount++][1];
				}
				
				if(tempCount <= posCount)
				{
					//if(class == CLASS_RUNNINGBACK || class == CLASS_RECEIVER || class == CLASS_LINEMAN)
					//server_print( "AFTER Origin ( %f, %f )", positive[tempCount][0], positive[tempCount][1] );
					ClassOriginX[formation][class][x] = positive[tempCount][0];
					ClassOriginY[formation][class][x++] = positive[tempCount++][1];
				}
			}
		}
	}

}