/*------- EDITABLES --------*/

#define STAMINA_DAMAGE	(damage / 3)

//Defaults player spawns with
#define BASE_STAMINA		100.0
#define BASE_SPEED			250.0
#define BASE_HEALTH			100.0

//Base amount of stamina ability costs
#define PRICE_TURBO_QUICK	25.0
#define PRICE_TURBO_LONG	25.0
#define PRICE_SAFETY_TURBO	25.0
#define PRICE_OLDDIVE		50.0
#define PRICE_DIVE			50.0
#define PRICE_JUMP			15.0
#define PRICE_SAFETY_JUMP	25.0
#define PRICE_TACKLE		60.0
#define PRICE_STIFFARM		0.0
#define PRICE_THROW			50.0
#define PRICE_TACKLED		0.0
#define PRICE_STIFFARM_BALLHOLDER 50.0
#define PRICE_RB_HOLDER_TURBO 40.0

//Length effect lasts.
#define	TURBO_QUICK_LENGTH	3.0


//Delays between ability uses
#define DELAY_TURBO_QUICK	10.0
#define DELAY_TURBO_LONG	1.0
#define DELAY_DIVE			3.0
#define DELAY_TACKLED		5.0
#define DELAY_DIVE_GETUP	0.5


#define TEAM_AGI_BONUS		0.2

//Strength = Tackling, StiffArm(push back)
//Dexterity = Throwing
//Agility = Running, Turbo, Jumping, Diving
//Weight = Damage absorbing, Push Back strength.
#define HOLDER_AGI 			0.8
#define RECEIVER_AGI 		1.1	
#define RUNNINGBACK_AGI 	1.0
#define LINEBACKER_AGI 		0.9
#define LINEMAN_AGI 		0.8
#define QUARTERBACK_AGI 	0.8
#define SAFETY_AGI 			1.3	
#define KICKER_AGI 			1.2	

#define HOLDER_STR 			1.0
#define RECEIVER_STR 		0.4
#define RUNNINGBACK_STR 	0.7
#define LINEBACKER_STR 		0.8
#define LINEMAN_STR 		1.0
#define QUARTERBACK_STR 	0.5
#define SAFETY_STR 			1.1
#define KICKER_STR			0.7

#define HOLDER_DEX 			1.0
#define RECEIVER_DEX 		0.5
#define RUNNINGBACK_DEX 	0.6
#define LINEBACKER_DEX 		0.7
#define LINEMAN_DEX 		0.5
#define QUARTERBACK_DEX 	1.0
#define SAFETY_DEX 			1.0
#define KICKER_DEX 			0.8	

#define HOLDER_WEIGHT		0.7
#define RECEIVER_WEIGHT		0.2
#define RUNNINGBACK_WEIGHT	0.7
#define LINEBACKER_WEIGHT	0.75
#define LINEMAN_WEIGHT		1.0
#define QUARTERBACK_WEIGHT	0.3
#define SAFETY_WEIGHT		0.3
#define KICKER_WEIGHT		0.3

//Yard distances
#define YARD_FG_POST				112.0 //112 yards to FG post, +7 yards for the distance behind scrimmage.
#define YARD_GOALLINE				100.0
#define YARD_TOUCHBACK				20.0
#define YARD_PUNT_PENALTY			40.0
#define YARD_KICKOFF				30.0
#define YARD_EXTRAPOINTS			95.0

//Misc.
#define RESTART_STATE_TIME 	5.1		//Time between plays
#define TASKTIME_RESETGAME_TOURNAMENT 2.0 //Reset time for Tournament mode (Do it quick!)
#define TASKTIME_RESETGAME	15.0	//Time before game resets and starts over.

#define MIN_KICK_DISTANCE	15.0	//Default( 15 ) - Yards needed for legal onside kick
#define FIRST_DOWN_YARDS 	20.0	//Default( 20 ) - Yards needed to complete a first down.

//EndZone Special Effects
#define PULSE_FREQUENCY		0.7 //in seconds
#define WAVE_COLOR_RED		0
#define WAVE_COLOR_GREEN	255
#define WAVE_COLOR_BLUE		0

#define UNSTUN_TIME_MIN  0.0
#define UNSTUN_TIME_MAX  0.1

/*---------------------------*/