Handle_PreSpawn( id )
{
	if(!is_user_connected(id))
		return;
		
	//Do we have a class?
	if(GetDefaultClass(id) != 0)
		return;
		
	//Is this our first time joining map?
	if( !g_IsFirstSpawn[id] )
	{
		HelpMsg(id);	
		g_IsFirstSpawn[id] = true;
	}
		
	//g_iPlayerTeam[id] = get_user_team(id);
	
	//Let player roam around harmlessly until he chooses class.
	new effects = entity_get_int( id, EV_INT_effects );
	entity_set_float( id, EV_FL_takedamage, 0.0 );
	entity_set_int( id, EV_INT_solid, 0 );
	entity_set_int( id, EV_INT_effects, effects | EF_NODRAW );
	entity_set_int(id, EV_INT_movetype, MOVETYPE_NOCLIP );
	strip_user_weapons(id);
	g_iWeapon[id] = 0;
	
	//Our Class Menu picker.
	cmdChangeClass(id);
	
	Handle_PostSpawn(id);
}


Handle_PostSpawn(id)
{
	if(!is_user_connected(id))
		return;
		
	if(GetDefaultClass(id) == 0)
		return;
		
	//Set player and ball positions
	Handle_PlayerSpawn(id)
	
	//Manage our abilities at spawn.
	Ability_Spawn(id);
	
	//Create_PlayerCamera( id );
}

public Handle_PlayerSpawn(id)
{
	if(g_iGameMode == GAME_NONE || !g_bGameStart)
	{
		Give( id, "weapon_knife" );
		return;
	}
	
	//new startTeam = GetBallData( BALL_START_TEAM );
	//new team = get_user_team(id);//g_iPlayerTeam[id];
	
	if(g_bPlayClockOn)
		//Class_PlayerSpawn(id);
		//Class_NeedSpecial(id, team);
		
	//new class = GetClass(id);
	
	strip_user_weapons(id);
	g_iWeapon[id] = 0;
	if(user_has_weapon(id, CSW_HEGRENADE))
	{
		cs_set_user_bpammo( id, CSW_HEGRENADE, 0);
		entity_set_string(id, EV_SZ_weaponmodel, "models/p_bknuckles.mdl")
	}
	
	Give( id, "weapon_knife" );
	
	set_task( 0.1, "PlayerPosition", id+53743 );
}

public PlayerPosition(id)
{
	id-= 53743;
	MoveToPosition(id, g_flCurrentYard);
	ToggleDeath(id, 0);

	new startTeam = GetBallData( BALL_START_TEAM );
	new team = get_user_team(id);//g_iPlayerTeam[id];
	new class = GetClass(id);
	
	if(g_bPlayClockOn)
	{
		if(team == startTeam)
		{
			if(g_iPlay == PLAY_STANDARD)
			{
				if(class == CLASS_QUARTERBACK)
				{
					FreezePlayer(id, true, 0);
					Football_Give(id);
					return;
				}
			}
			else if(class == CLASS_KICKER)
			{
				switch(g_iPlay)
				{
					case PLAY_FIELDGOAL:
					{
						FreezePlayer(id, true, 0);
						Football_Spawn( FLY_FG_HOLD );
						return;
					}
					case PLAY_PUNT:
					{
						FreezePlayer(id, true, 0);
						Football_PuntHold(id, true );
						return;	
					}
					case PLAY_KICKOFF:
					{
						//FreezePlayer(id, false);
						Football_Spawn( FLY_KICK_HOLD );
						return;
					}
				}
			}
		}
		FreezePlayer(id, true);
	}		
}


MoveToPosition(id, Float:yard, bool:changeAngle=true )
{
	//new bool:freeze = true;
	new team = get_user_team(id);
	new startTeam = GetBallData( BALL_START_TEAM );
	new Float:yardOrig = GetOriginYard( yard );
	new Float:origin[3];
	new dir = GetBallData(BALL_DIRECTION);
	new class = GetClass(id);
	
	//If we died put us where we died.
	if( ToggleDeath(id) && !g_bPlayClockOn)
 	{
	 	new Float:pOrig[3];
		new Float:pVel[3];
	 	GetLastPlayerPos(id, pOrig );
	 	origin[0] = pOrig[0];
	 	origin[1] = pOrig[1];
	 	
	 	
	 	pVel[0] = random_float( -300.0, 300.0 );
	 	pVel[1] = random_float( -300.0, 300.0 );
	 	pVel[2] = random_float( 100.0, 250.0 );
	 	entity_set_vector(id, EV_VEC_velocity, pVel );
 	}
 	else
 	{
	 	GetSpawn( id, origin );
			
	 	
	 	if(g_iPlay == PLAY_FIELDGOAL && class == CLASS_KICKER)// == kicker)
			origin[0] *= dir;
		
		if(g_iPlay == PLAY_KICKOFF && team != startTeam)
			yardOrig = 0.0;
			
		if(class == CLASS_LINEMAN && g_iPlay == PLAY_STANDARD)
			yardOrig = GetOriginYard( yard + (team==startTeam?-1:1) );
	
		origin[1] = yardOrig + (origin[1] * dir) + ((team==startTeam ? dir : -dir) * 2.0); 
		origin[2] = g_vSideLine[0][2] + 36; //Ground origin + half height of player
		
		if(g_bPlayerFrozen[id])
		{
			g_vPlayerPos[id][0] = origin[0];
			g_vPlayerPos[id][1] = origin[1];
			g_vPlayerPos[id][2] = origin[2];
		}
 	}
 	
 	new Float:vel[3];
 	entity_set_vector( id, EV_VEC_velocity, vel );
	entity_set_vector( id, EV_VEC_origin, origin );	
	if(changeAngle==true)
	{
		new Float:pAng[3];
		
		if(team != startTeam)
			dir = -dir;
			
		pAng[1] = float(dir) * 90.0;

		if(g_iPlay == PLAY_FIELDGOAL && class == CLASS_KICKER)
			pAng[1] -= 30;
	
		entity_set_vector( id, EV_VEC_angles, pAng );
		entity_set_vector( id, EV_VEC_v_angle, pAng );
	}
}

UnfreezeAll()
{
	new id;
	for(id=1;id<=g_iMaxplayers;id++)
		if(is_user_connected(id))
		{
			g_bActivateAttack[id] = true;
			FreezePlayer(id, false);	
			g_bPlayerFrozen[id] = false;
		}
}

FreezePlayer(id, bool:on, type=1)
{
	new flags = entity_get_int( id, EV_INT_flags );

	if(on)
	{
		if(type == 0)
		{
			set_user_footsteps(id, 1);
			entity_get_vector(id, EV_VEC_origin, g_vPlayerPos[id] );
			g_bPlayerFrozen[id] = true;	
		}
		else
			entity_set_int( id, EV_INT_flags, (flags | FL_FROZEN) );	
	}	
	else
	{
		set_user_footsteps(id, 0);
		g_bPlayerFrozen[id] = false;
		entity_set_int( id, EV_INT_flags, (flags & ~FL_FROZEN) );	
	}
}

Handle_Disconnect(id)//public client_disconnect(id)
{
	new i, x, a;
	new count;
	
	//clear any reserved positions this player had.
	for(x=0;x<FORMATION_COUNT;x++)
		for(i=0;i<SPAWN_POSITIONS;i++)
		{
			count = Count[x][i];
			for(a=0;a<count;a++)
				if(Reserved[x][i][a] == id)
					Reserved[x][i][a] = 0;	
		}	
}

//native ClearReserved()
ClearReserved()
{
	new formation, class, count, pos;
	
	
	
	//clear all reserved positions
	for(formation=0;formation<FORMATION_COUNT;formation++)
		for(class=0;class<SPAWN_POSITIONS;class++)
		{
			//arrayset( Reserved[formation][class], 0, MAX_SPAWNS );
			
			count = Count[formation][class];
			for(pos=0;pos<count;pos++)
				Reserved[formation][class][pos] = 0;	
			
		}	
	
}

/*
//native RemoveReserved( id );
RemoveReserved( id )
{
	new pos, formation, class, count;
	
	//clear any reserved positions this player had.
	for(formation=0;formation<FORMATION_COUNT;formation++)
		for(class=0;class<SPAWN_POSITIONS;class++)
		{
			count = Count[formation][class];
			for(pos=0;pos<count;pos++)
				if(Reserved[formation][class][pos] == id)
					Reserved[formation][class][pos] = 0;	
		}	
}
*/

//native GetSpawn( id, Float:origin[2], special=-1 );
GetSpawn( id, Float:origin[3] )
{
	new formation = GetFormation(id);
   	new pclass = GetClass(id);
 	if(pclass > CLASS_LINEMAN)
 		pclass = 0;

   	GetPosition( id, formation, pclass, origin );
}

//native ChangeSpawnPosition( id );
ChangeSpawnPosition( id )
{
	new class = GetClass(id);
	if(class > CLASS_LINEMAN)
 		return;
 		
	new formation = GetFormation(id);
	if(formation == -1)
		return;
		
	new i, oldpos;
	new count
	
	count = Count[formation][class];
	
	for(i=0;i<count;i++)
		if(Reserved[formation][class][i] == id)
			oldpos = i;
			
	i = oldpos;	
	
	do
	{
		i++;
		if(i >= count) i = 0;
				
		if(Reserved[formation][class][i] == 0)
		{
			Reserved[formation][class][oldpos] = 0;
			Reserved[formation][class][i] = id;	
			break;
		}
	} while( i != oldpos )
	
	MoveToPosition(id, g_flCurrentYard);
}

GetPosition( id, formation, class, Float:origin[3] )
{
	if(class == 0)
	{
		origin[0] = ClassOriginX[formation][class][0];
		origin[1] = ClassOriginY[formation][class][0];
		//client_print(0,print_chat, "ID: %i , Formation: %i , Class %i , origin (%f,%f)", id, formation, class, origin[0], origin[1] );
		return;
	}	
	new count = Count[formation][class];
	new i;
	//If we have a position already, get it.
	for(i=0;i<count;i++)
		if(Reserved[formation][class][i] == id)
		{
			origin[0] = ClassOriginX[formation][class][i];
			origin[1] = ClassOriginY[formation][class][i];
			return;
		}
				
	//If we don't reserve one!	
	for(i=0;i<count;i++)
	{
		if( Reserved[formation][class][i] == 0 )
		{
			Reserved[formation][class][i] = id;
			origin[0] = ClassOriginX[formation][class][i];
			origin[1] = ClassOriginY[formation][class][i];
			return;
		}
	}
	
	client_print(id, print_chat, "There's no open positions for you on the field!" );
	log_amx( "-----------------------------------------------" );
	log_amx( "GameState = %i | ID = %i", g_iPlay, id );
	log_amx( "Formation = %i | Class = %i | Count = %i", formation, class, count );
	new x;
	for(i=0;i<count;i++)
	{
		x = Reserved[formation][class][i];
		log_amx( "Reserved [%i] = %i - Team %i - Class %i", i, x, get_user_team(x), GetClass(x));
	}
	log_amx( "-----------------------------------------------" );
	return;
}

GetBallOrigin( Float:origin[3], formpos )
{
	origin[0] = g_flBallYOrig[formpos][0];
	origin[1] = g_flBallYOrig[formpos][1];
	origin[2] = g_vSideLine[0][2] + 15;
	//server_print( "BallOrigY = %f",BallKickOrigin[formpos][1]);
	//return 1;	
}