

//Holds the stat player made this play.
new g_iPlayerStat[MAX_PLAYERS];

//Holds current play stats.
new g_iStat[MAX_PLAYERS][S_TOTAL_COUNT];

//Holds current game stats.
new g_iGameStat[MAX_PLAYERS][S_TOTAL_COUNT];

//Holds players overall stats from every game.
//new g_iGlobal[MAX_PLAYERS][S_TOTAL_COUNT];

STATISTIC( id, stat, value )
{
	g_iStat[id][stat] += value;		//Accumilate stat.
	g_iPlayerStat[id] |= (1<<stat); //Flag this stat for player
}

GetGameStat( id, stat )
{
	return g_iGameStat[id][stat];	
}

/*
GetGlobalStat( id, stat )
{
	return g_iGlobal[id][stat];	
}
*/

GetStat( id, stat )
{
	return g_iStat[id][stat];	
}

/*
//Add current play stats to GameStats and GlobalStats, and clear play stats.
Stat_SaveReset()
{
	//Get a list of players that have stat marked.
	new id;
	new players[32], count;
	for(id=1; id<=g_iMaxplayers; id++)
	{
		if(g_iPlayerStat[id] > 0)
			players[count++] = id;
	}	
	
	//Use the list to add to our globals and reset.
	new x;
	new stat, bitStat;
	for(x=0; x<count; x++)
	{
		id = players[x];
		for(stat=0; stat<S_TOTAL_COUNT; stat++)
		{
			bitStat = (1<<stat);
			if( g_iPlayerStat[id] & bitStat )
			{
				g_iGameStat[id][stat] += g_iStat[id][stat];
				g_iGlobal[id][stat] += g_iStat[id][stat];
				g_iStat[id][stat] = 0;
				g_iPlayerStat[id] &= ~bitStat;
			}	
		}
	}
}
*/

Stat_EndPlay()
{
	//new flytype = GetBallData( BALL_FLY );
	new ballTeam = GetBallData( BALL_TEAM );
	new startTeam = GetBallData( BALL_START_TEAM );
	//new otherTeam = startTeam == 1 ? 2 : 1;
	
	//new holder = GetBallData( BALL_HOLDER );
	new owner = GetBallData( BALL_OWNER );
	
	new kicker;//, safety, qb;
	//qb = GetCurrentSpecial( ballTeam, CLASS_QUARTERBACK );
	kicker = GetCurrentSpecial( ballTeam, CLASS_KICKER );
	//safety = GetCurrentSpecial( otherTeam, CLASS_SAFETY );
	
	new otherQB = GetBallData( BALL_THROW_PLAYER );
	
	new Float:startTeamYard = g_flStartYard[startTeam];
	new Float:ballTeamYard = g_flStartYard[ballTeam];
	new bool:bTouchdown = (g_iLastEvent == SCORE_TOUCHDOWN);
	new bool:isStartTeam = (ballTeam == startTeam);
	
	switch(g_iPlay)
	{
		case PLAY_KICKOFF:
		{
			if(isStartTeam)
			{
				new totalYards = floatround(g_flCurrentBallYard - startTeamYard);
				
				new kickerFrags = get_user_frags(kicker);
				entity_set_float(kicker, EV_FL_frags, float(kickerFrags+2));
			
				new ownerFrags = get_user_frags(owner);
				if(totalYards > 0)
					ownerFrags += 1;
					
				
				STATISTIC( kicker, S_KICK_ONSIDE_RECOVERED, 1 );
				STATISTIC( owner, S_TURNOVER, 1 );
				STATISTIC( owner, S_TURNOVER_YARDS, totalYards );
				
				if(bTouchdown)
				{
					STATISTIC( owner, S_TURNOVER_TD, 1 );
					ownerFrags += 1;
				}	
				
				if( GetGameStat( owner, S_TURNOVER_LONG ) < totalYards )
				{
					STATISTIC( owner, S_TURNOVER_LONG, totalYards );
					STATISTIC( owner, S_TURNOVER_LONG_TD, (bTouchdown ? 1 : 0) );
				}
				
				entity_set_float(owner, EV_FL_frags, float(ownerFrags));
			}
			else
			{
				new totalYards = floatround(g_flCurrentBallYard - ballTeamYard);
				
				new ownerFrags = get_user_frags(owner);
				if(totalYards > 0)
					ownerFrags += 1;
					
				STATISTIC( kicker, S_KICK_RETURN, 1 );
				STATISTIC( kicker, S_KICK_RETURN_YARDS, totalYards );
				
				if(bTouchdown)
				{
					ownerFrags += 1;
					STATISTIC( kicker, S_KICK_RETURN_TD, 1 );
					STATISTIC( owner, S_RETURN_KICK_TD, 1 );
				}
					
				if( GetGameStat( owner, S_RETURN_KICK_LONG ) < totalYards )
				{
					STATISTIC( owner, S_RETURN_KICK_LONG, totalYards );
					STATISTIC( owner, S_RETURN_KICK_LONG_TD, (bTouchdown ? 1 : 0) );
				}
					
				STATISTIC( owner, S_RETURN_KICK, 1 );
				STATISTIC( owner, S_RETURN_KICK_YARDS, totalYards );
				
				entity_set_float(owner, EV_FL_frags, float(ownerFrags));
			}
		}
		case PLAY_PUNT:
		{
			if(isStartTeam)
			{
				new totalYards = floatround(g_flCurrentBallYard - startTeamYard);
				STATISTIC( owner, S_TURNOVER, 1 );
				STATISTIC( owner, S_TURNOVER_YARDS, totalYards );
				
				new ownerFrags = get_user_frags(owner);
				if(totalYards > 0)
					ownerFrags += 1;
					
				if(bTouchdown)
				{
					ownerFrags += 1;
					STATISTIC( owner, S_TURNOVER_TD, 1 );	
				}
				
				if( GetGameStat( owner, S_TURNOVER_LONG ) < totalYards )
				{
					STATISTIC( owner, S_TURNOVER_LONG, totalYards );
					STATISTIC( owner, S_TURNOVER_LONG_TD, (bTouchdown ? 1 : 0) );
				}
				entity_set_float(owner, EV_FL_frags, float(ownerFrags));
			}
			else
			{
				new totalYards = floatround(g_flCurrentBallYard - ballTeamYard);
				
				STATISTIC( owner, S_RETURN_PUNT, 1 );
				STATISTIC( owner, S_RETURN_PUNT_YARDS, totalYards );
			
				new ownerFrags = get_user_frags(owner);
				if(totalYards > 0)
					ownerFrags += 1;
					
				if(bTouchdown)
				{
					ownerFrags += 1;
					STATISTIC( owner, S_RETURN_PUNT_TD, 1 );
				}
					
				if( GetGameStat( owner, S_RETURN_PUNT_LONG ) < totalYards )
				{
					STATISTIC( owner, S_RETURN_PUNT_LONG, totalYards );
					STATISTIC( owner, S_RETURN_PUNT_LONG_TD, (bTouchdown ? 1 : 0) );
				}
				entity_set_float(owner, EV_FL_frags, float(ownerFrags));
			}
		}
		case PLAY_FIELDGOAL:
		{
			if(!isStartTeam)
			{
				new totalYards = floatround(g_flCurrentBallYard - ballTeamYard);
				STATISTIC( owner, S_TURNOVER, 1 );
				STATISTIC( owner, S_TURNOVER_YARDS, totalYards );
				
				new ownerFrags = get_user_frags(owner);
				if(totalYards > 0)
					ownerFrags += 1;
					
				if(bTouchdown)
				{
					ownerFrags += 1;
					STATISTIC( owner, S_TURNOVER_TD, 1 );	
				}
				
				if( GetGameStat( owner, S_TURNOVER_LONG ) < totalYards )
				{
					STATISTIC( owner, S_TURNOVER_LONG, totalYards );
					STATISTIC( owner, S_TURNOVER_LONG_TD, (bTouchdown ? 1 : 0) );
				}
				entity_set_float(owner, EV_FL_frags, float(ownerFrags));
			}
		}
		case PLAY_STANDARD:
		{
			if(g_bExtraPoint)
				return;
				
			new throwType = GetBallData( BALL_THROW_FLY );
			
			if(isStartTeam)
			{
				new totalYards = floatround( g_flCurrentBallYard - startTeamYard );
				if(throwType == FLY_PASS)
				{
					STATISTIC( otherQB, S_PASS_COMPLETE, 1 );
					STATISTIC( otherQB, S_PASS_YARDS, totalYards );
					
					new ownerFrags = get_user_frags(owner);
					new otherQBFrags = get_user_frags(otherQB);
					if(totalYards > 0)
					{
						otherQBFrags += 1;
						ownerFrags += 1;
					}
					
					STATISTIC( owner, S_RECV_RECEIVES, 1 );
					STATISTIC( owner, S_RECV_YARDS, totalYards );
					
					if(g_flCurrentBallYard >= g_flTargetYard)
					{
						otherQBFrags += 1;
						ownerFrags += 1;
						
						STATISTIC( otherQB, S_PASS_FIRSTDOWN, 1 );
						STATISTIC( owner, S_RECV_FIRSTDOWN, 1 );
					}
						
					if(bTouchdown)
					{
						otherQBFrags += 1;
						ownerFrags += 1;
						
						STATISTIC( otherQB, S_PASS_TD, 1 );
						STATISTIC( owner, S_RECV_TD, 1 );
					}
					
					new long = GetStat( otherQB, S_PASS_LONG );
					if(long < totalYards)
					{
						STATISTIC( otherQB, S_PASS_LONG, 1 );
						STATISTIC( otherQB, S_PASS_LONG_TD, bTouchdown ? 1 : 0 );	
					}
					
					long = GetStat( owner, S_RECV_LONG );
					if(long < totalYards)
					{
						STATISTIC( owner, S_RECV_LONG, 1 );
						STATISTIC( owner, S_RECV_LONG_TD, bTouchdown ? 1 : 0 );	
					}
					
					entity_set_float(otherQB, EV_FL_frags, float(otherQBFrags));
					entity_set_float(owner, EV_FL_frags, float(ownerFrags));
				}	
				else if(throwType == FLY_HANDOFF)
				{
					STATISTIC( owner, S_RUSH_ATTEMPT, 1 );
					STATISTIC( owner, S_RUSH_YARDS, totalYards );
					
					new ownerFrags = get_user_frags(owner);
					if(totalYards > 0)
						ownerFrags += 1;
			
					
					if(g_flCurrentBallYard >= g_flTargetYard)
					{
						ownerFrags += 2;
						STATISTIC( owner, S_RUSH_FIRSTDOWN, 1 );
					}
						
					if(bTouchdown)
					{
						ownerFrags += 1;
						STATISTIC( owner, S_RUSH_TD, 1 );
					}
					
					new long = GetStat( owner, S_RUSH_LONG );
					if(long < totalYards)
					{
						STATISTIC( owner, S_RUSH_LONG, 1 );
						STATISTIC( owner, S_RUSH_LONG_TD, bTouchdown ? 1 : 0 );	
					}
					entity_set_float(owner, EV_FL_frags, float(ownerFrags));
				}
			}
			else
			{
				new totalYards = floatround( g_flCurrentBallYard - ballTeamYard );
				if(throwType == FLY_PASS)
				{
					STATISTIC( owner, S_INT_YARDS, totalYards );
					
					new ownerFrags = get_user_frags(owner);
					if(totalYards > 0)
						ownerFrags += 1;
							
					if(bTouchdown)
					{
						ownerFrags += 1;
						STATISTIC( owner, S_INT_TD, 1 );
					}
					
					new long = GetStat( owner, S_INT_LONG );
					if(long < totalYards)
					{
						STATISTIC( owner, S_INT_LONG, 1 );
						STATISTIC( owner, S_INT_LONG_TD, bTouchdown ? 1 : 0 );	
					}
					
					entity_set_float(owner, EV_FL_frags, float(ownerFrags));
				}
				else
				{
					STATISTIC( owner, S_TURNOVER, 1 );
					STATISTIC( owner, S_TURNOVER_YARDS, totalYards );
					
					new ownerFrags = get_user_frags(owner);
					if(totalYards > 0)
						ownerFrags += 1;
						
					if(bTouchdown)
					{
						ownerFrags += 1;
						STATISTIC( owner, S_TURNOVER_TD, 1 );
					}	
					
					if( GetGameStat( owner, S_TURNOVER_LONG ) < totalYards )
					{
						STATISTIC( owner, S_TURNOVER_LONG, totalYards );
						STATISTIC( owner, S_TURNOVER_LONG_TD, (bTouchdown ? 1 : 0) );
					}
					entity_set_float(owner, EV_FL_frags, float(ownerFrags));
				}
			}
		}
	}
	
	//Stat_Display();
}

/*
Stat_TouchBall(player)
{
	//new team = get_user_team(player);
	new Float:origin[3];
	entity_get_vector(player, EV_VEC_origin, origin );
	
	g_flStartYard[team] = GetYard( origin[1] );
}

Stat_ThrowBall(player)
{
}
*/

public cmdStatDisplay(id)
{
	
	new stat, bitStat;
	for(stat=0;stat<S_TOTAL_COUNT;stat++)
	{
		bitStat = (1<<stat);
		if(g_iPlayerStat[id] & bitStat )
		{
			client_print(id, print_console, "%s = %i", g_szStatNames[stat], g_iStat[id][stat] );
		}	
	}
	/*
	new szStatMsg[1024], length;
	new id, players[32], count;
	new x, stat, bitStat;
	new pname[32];
	
	new ballTeam = GetBallData(BALL_TEAM);
	new startTeam = GetBallData(BALL_START_TEAM);
	new qb, safety, kicker;
	if(g_iLastPlay == PLAY_STANDARD)
		qb = GetSpecial(startTeam, CLASS_QUARTERBACK );
		
	//Get a list of players that have stat marked.
	for(id=1; id<=g_iMaxplayers; id++)
	{
		if(g_iPlayerStat[id] > 0)
			players[count++] = id;
	}	
	
	length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
	
	//Use the list to add to our globals and reset.
	for(x=0; x<count; x++)
	{
		id = players[x];
		get_user_name(id, pname, 31 );
		
		for(stat=0; stat<S_TOTAL_COUNT; stat++)
		{
			bitStat = (1<<stat);
			if( g_iPlayerStat[id] & bitStat )
			{
				switch(stat)
				{
					case S_PASS_ATTEMPT:			length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_COMPLETE:			length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_YARDS:				length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_FIRSTDOWN:			length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_INTERCEPT:			length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_FUMBLE:				length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_FUMBLE_RECOVER:		length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_SACK:				length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_SACK_YARDS:			length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_LONG:				length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_LONG_TD:			length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_PASS_TD:					length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					
					case S_RECV_RECEIVES:			length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_RECV_YARDS:				length += format( szStatMsg[len], 1024-len, "------- STATS ---------" );
					case S_RECV_FIRSTDOWN:			
					case S_RECV_LONG:				
					case S_RECV_LONG_TD:
					case S_RECV_TD:
					
					case S_RUSH_ATTEMPT:
					case S_RUSH_YARDS:
					case S_RUSH_FIRSTDOWN:
					case S_RUSH_LONG:
					case S_RUSH_LONG_TD:
					case S_RUSH_TD:
					
					case S_LINEMAN_SACK_ALLOWED:
					case S_LINEMAN_BLOCK:
					case S_LINEMAN_PANCAKE:
					
					case S_DEF_SACK:
					case S_DEF_SACKASSIST:
					case S_DEF_TACKLE:
					case S_DEF_TACKLE_ASSIST:
					case S_DEF_FUMBLE_FORCE:
					case S_DEF_FG_BLOCK:
					case S_DEF_PUNT_BLOCK:
					
					case S_FUMBLE:			
					case S_FUMBLE_RECOVER:
					
					case S_TURNOVER:
					case S_TURNOVER_YARDS:		
					case S_TURNOVER_TD:			
					case S_TURNOVER_LONG:		
					case S_TURNOVER_LONG_TD:		
					
					case S_INT:
					case S_INT_YARDS:
					case S_INT_TD:
					case S_INT_LONG:
					case S_INT_LONG_TD:
					
					case S_RETURN_PUNT:
					case S_RETURN_PUNT_YARDS:
					case S_RETURN_PUNT_TD:
					case S_RETURN_PUNT_LONG:
					case S_RETURN_PUNT_LONG_TD:
					
					case S_RETURN_KICK:
					case S_RETURN_KICK_YARDS:
					case S_RETURN_KICK_TD:
					case S_RETURN_KICK_LONG:
					case S_RETURN_KICK_LONG_TD:
					
					case S_PUNT_ATTEMPT:
					case S_PUNT_YARDS:
					case S_PUNT_OUTOFBOUND:
					case S_PUNT_TOUCHBACK:
					case S_PUNT_IN20:
					case S_PUNT_BLOCK:
					case S_PUNT_LONG:
					
					case S_FG_ATTEMPT_0:
					case S_FG_MADE_0:
					case S_FG_ATTEMPT_20:
					case S_FG_MADE_20:
					case S_FG_ATTEMPT_30:
					case S_FG_MADE_30:
					case S_FG_ATTEMPT_40:
					case S_FG_MADE_40:
					case S_FG_ATTEMPT_50:
					case S_FG_MADE_50:
					case S_FG_YARDS:
					case S_FG_LONG:
					case S_FG_BLOCK:
					
					case S_KICK_ATTEMPT:
					case S_KICK_OUTOFBOUND:
					case S_KICK_TOUCHBACK:
					case S_KICK_ONSIDE_ATTEMPT:
					case S_KICK_ONSIDE_RECOVERED:
					case S_KICK_RETURN:
					case S_KICK_RETURN_TD:
					case S_KICK_RETURN_YARDS:	
				}
			}	
		}
	}
	*/
	
	
}


