
Handle_UI()
{
	DisplayStatus();
	DisplayClass();
}	

DisplayStatus()
{
	//new hudmsg[128];
	new len;
	new hasball[4], tabs[6];
	new x;
	new teamBall = GetBallData( BALL_TEAM );
	new quarter = g_iQuarter;
	
	if(g_iQuarter > 4)
		len += format( g_HudMsg2[len], 1023-len, "Sudden Death ^n" );
	else
		len += format( g_HudMsg2[len], 1023-len, "%i%s Quarter ^n", quarter, g_szSuffix[quarter] );
		
	for(x=1;x<3;x++)
	{
		tabs[0] = 0;
		if(x == T)
			format(tabs, 5, "^t" );
		else
			format(tabs, 5, "" );
		if(teamBall == x)
		{
			format(hasball, 3, "<> " );
		}
		else 
		{
			format(hasball, 3, "^t^t " );
			//format(tabs, 5, "^t^t" );
		}
			
		len += format( g_HudMsg2[len], 1023-len, "%s%s%s - %i^t ^n", hasball, x==T?"T":"CT", tabs, g_iScore[x] );	
	}
	
	if(g_iPlay != PLAY_KICKOFF && !g_bExtraPoint )
	{
		new yards[12];
		new Float:needed = g_flTargetYard - g_flCurrentYard;
		if( needed < 1.0 )
			format(yards, 11, "inches" );
		else
			format(yards, 11, "%i", floatround(needed) );
		new down = g_iDown;
		if(down < 1)
			down = 1;
		else if(down > 4)
			down = 4;
			
		len += format( g_HudMsg2[len], 1023-len, "%i%s & %s ^n", (down), g_szSuffix[down], yards );
	}
	
	if(IsPlayClockOn())
		FX_StatusIcon( g_iPlayClock );
	//else
	//{
	//	FX_StatusIcon( -1 );	
	//}
	
}

DisplayClass()
{
	new id, team, class, len;

	new temp[64];
	AddHangTime( temp, 63 );
	
	static Float:delay = 0.0;
	new Float:gametime = get_gametime();
	
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if(is_user_connected(id))
		{
			team = get_user_team(id);
			if(team != 1 && team != 2)
				continue;
				
			class = GetClass(id);
			
			if(class > 0)
			{
				len = FormatClassName( id, team, class, g_HudMsg1[id], 127 );
				len += Meter( id, g_HudMsg1[id][len], 127-len);
				len += format(g_HudMsg1[id][len], 127-len, "%s", temp );
				len = 0;
			}	
		}	
	}
	
	if(gametime > delay)
		delay = gametime + 0.15;
}			

AddHangTime( classname[], asize )
{

	static Float:hangtime = 0.0;
	static Float:delaytime = 0.0;
	new len;
	new Float:gametime = get_gametime();
	new flytype = GetBallData( BALL_FLY );//GetFlytype();
	
	if(!g_bTouchedGround && (flytype == FLY_KICK || flytype == FLY_PUNT))
	{
		hangtime += 0.1;	
		delaytime = gametime + 3.0;
	}
	else if(flytype == FLY_KICK_HOLD || flytype == FLY_PUNT_HOLD)
		hangtime = 0.0;
			
	
	if(delaytime > gametime)
	{
		len = format( classname, asize, "^n^n-HangTime-^n%.1f seconds", hangtime );
	}
	
	return len;
}

FormatClassName( id, team, class, classname[], asize )
{
	new len;
	if(team == 1 || team == 2)
	{
		//client_print(id,print_center, "Class = %i", class );
		if(class >= CLASS_QUARTERBACK)
		{
			class -= CLASS_QUARTERBACK;
			len += format( classname[len], asize-len, "%s", g_szSpecial[class] );
		}
		else
		{
			new formation = GetFormation(id);
			switch(formation)
			{
				case OFFENSE:			len += format( classname[len], asize-len, "%s", g_szOffense[class] );
				case DEFENSE:			len += format( classname[len], asize-len, "%s", g_szDefense[class] );
				case KRETURN:			len += format( classname[len], asize-len, "%s", g_szDefense[class] );
				case KRECEIVE:			len += format( classname[len], asize-len, "%s", g_szOffense[class] );
				case PUNT:				len += format( classname[len], asize-len, "%s", g_szOffense[class] );
				case PUNTRETURN:		len += format( classname[len], asize-len, "%s", g_szDefense[class] );
				case FIELDGOAL:			len += format( classname[len], asize-len, "%s", g_szOffense[class] );
				case FIELDGOALBLOCK:	len += format( classname[len], asize-len, "%s", g_szDefense[class] );
			}
		}
	}	
	
	return len;
}

public Meter( id, classname[], size )
{
	new len, i;
	static const Float:flTurboTime = 3.0;
	new Float:timeleft = get_gametime() - Ability_GetDelay(id,A_TURBO_QUICK);//g_flTurboDelay[id];
	new totalTime = floatround( (timeleft/flTurboTime) * 15.0 );
	new bool:bTurbo = Ability_IsActive(id, A_TURBO_QUICK);//g_iSprint[id] == 1;
	
	len += format(classname[len], size-len, "^n([ TURBO ])^n[");

	for(i=1; i<=14; i++)
	{
		if(i >= totalTime || !bTurbo)
			classname[len++] = '|';
		else
			classname[len++] = '=';
	}
	classname[len++] = ']';
	return len;
}

public HudPaint1()
{
	new id, team;
	
	for(id = 1; id <= g_iMaxplayers; id++)
	{
		if(!is_user_connected(id)) continue;
		
		team = get_user_team(id);
	
		if(team == T)
		{
			set_hudmessage(255, 0, 0, -1.0, 0.0, 0, 1.0, 1.5, 0.1, 0.1, CHANNEL1)
			show_hudmessage( id, "%s", g_HudMsg1[id] );
		}
		else if(team == CT)
		{
			set_hudmessage(0, 0, 255, -1.0, 0.0, 0, 1.0, 1.5, 0.1, 0.1, CHANNEL1)
			show_hudmessage( id, "%s", g_HudMsg1[id] );
		}
	}	
}

HelpMsg(id)
{
	client_print( id, print_chat, "Type .help for information on Football Mod!" );	
}

public cmdHelp(id)
{
	new filepath[256];
	new filename[64];
	get_localinfo("amxx_configsdir", filepath, 255);
	format(filename, 63, "/%s", HELP_MOTD_FILE );
	add(filepath, 255, filename);
	
	show_motd(id, filepath, "Football Help")
}

public HudPaint2()
{
	if(g_HudMsg2[0])
	{
		set_hudmessage(0, 255, 0, 0.94, 0.3, 0, 1.0, 1.5, 0.1, 0.1, CHANNEL2);
		show_hudmessage(0, "%s",g_HudMsg2);		
	}
		
}
public HudPaint3()
{
	if(g_HudMsg3[0])
	{
		set_hudmessage(20, 255, 20, -1.0, 0.4, 0, 1.0, 1.5, 0.1, 0.1, CHANNEL3)
		show_hudmessage(0, "%s", g_HudMsg3)
	}
}
public HudPaint4()
{
	new Float:gametime = get_gametime();
	if(g_MsgTime - gametime >= 0.0)
	{
		set_hudmessage(255, 0, 20, -1.0, 0.3, 0, 1.0, 1.5, 0.1, 0.1, CHANNEL4)
		show_hudmessage(0, "%s", g_HudMsg4)
	}
}