CreatePlayMenus()
{
	g_iTouchdownVote = menu_create("Choose Play:", "TouchdownHandler")
	menu_additem(g_iTouchdownVote, "Field Goal", "0", 0)
	menu_additem(g_iTouchdownVote, "Two Point Conversion", "1", 0)
	menu_setprop(g_iTouchdownVote, MPROP_EXIT, MEXIT_NEVER);
	
	new callback = menu_makecallback("FourthVoteCallback")
	
	g_iFourthVote = menu_create("Choose Play:", "FourthHandler")
	menu_additem(g_iFourthVote, "Attempt", "0", 0)
	menu_addblank(g_iFourthVote, 2);
	menu_additem(g_iFourthVote, "Punt", "1", 0, callback)
	menu_additem(g_iFourthVote, "Field Goal", "2", 0, callback)
	menu_setprop(g_iFourthVote, MPROP_EXIT, MEXIT_NEVER);
}

BeginVote( voteid, team )
{
	new id;
	new pteam;
	
	set_task( get_pcvar_float(P_VOTETIME) , "EndVote", voteid );
	
	g_iTouchdownItems[0] = 0;
	g_iTouchdownItems[1] = 0;
	
	g_iFourthItems[0] = 0;
	g_iFourthItems[1] = 0;
	g_iFourthItems[2] = 0;
	g_iVoteCount = 0;
	
	switch(voteid)
	{
		case VOTE_EXTRAPOINT:
		{
			for(id=1;id<=g_iMaxplayers;id++)
			{
				if(!is_user_connected(id) || GetDefaultClass(id) == 0)
					continue;
					
				pteam = get_user_team(id);
				if(pteam == team)
				{
					menu_display(id, g_iTouchdownVote, 0);
					g_iVoteCount++;
				}
			}	
		
		}
		case VOTE_FOURTHDOWN:
		{
			for(id=1;id<=g_iMaxplayers;id++)
			{
				if(!is_user_connected(id) || GetDefaultClass(id) == 0)
					continue;
					
				pteam = get_user_team(id);
				if(pteam == team)
				{
					menu_display(id, g_iFourthVote, 0);
					g_iVoteCount++;
				}
			}	
			
		}	
	}	
}


public TouchdownHandler(id, menu, item)
{
	if(g_iGameMode == GAME_NONE || !g_bGameStart)
		EndVote( VOTE_EXTRAPOINT );
		
	if(item == MENU_EXIT)
		return;
		
	if(g_iVoteCount == -1)
		return;
		
	if(!is_user_connected(id))
		return;
		
	new cmd[6], iName[64];
	new access, callback;
	menu_item_getinfo(menu, item, access, cmd,5, iName, 63, callback); 
	
	new item = str_to_num(cmd);
		
	g_iTouchdownItems[item]++;
	g_iVoteCount--;
	if(g_iVoteCount <= 0)
		EndVote( VOTE_EXTRAPOINT );	
}

public FourthVoteCallback(id, menu, item)
{
	if(item == MENU_EXIT)
		return ITEM_IGNORE;
	if(g_iVoteCount == -1)
		return ITEM_IGNORE;
	new info[128];
	
	if(item == 1)
	{
		if(g_flCurrentYard > 75.0)
			format(info, 127, "\rPunt (Unavailable)");	
		else
			format(info, 127, "Punt" );	
		menu_item_setname(menu, item, info);
	}
	else if(item == 2)
	{
		if(g_flCurrentYard < 45.0)
			format(info, 127, "\rField Goal (Unavailable)");	
		else
			format(info, 127, "Field Goal" );	
		menu_item_setname(menu, item, info);
	}
	return ITEM_IGNORE;
}

public FourthHandler(id, menu, item)
{
	if(g_iGameMode == GAME_NONE || !g_bGameStart)
		EndVote( VOTE_FOURTHDOWN );
		
	if(item == MENU_EXIT)
		return;
		
	if(g_iVoteCount == -1)
		return;
		
	if(!is_user_connected(id))
		return;
		
	new cmd[6], iName[64];
	new access, callback;
	menu_item_getinfo(menu, item, access, cmd,5, iName, 63, callback); 
	
	new item = str_to_num(cmd);
		
	if(item == 1 && g_flCurrentYard > 75.0)
	{
		menu_display(id, g_iFourthVote, 0);
		return;
	}
	
	if(item == 2 && g_flCurrentYard < 45.0)
	{
		menu_display(id, g_iFourthVote, 0);
		return;
	}
	
	g_iFourthItems[item]++;
	g_iVoteCount--;
	if(g_iVoteCount <= 0)
		EndVote( VOTE_FOURTHDOWN );	
}

public EndVote(voteid)
{	
	remove_task(voteid);
	
	if(g_iGameMode == GAME_NONE || !g_bGameStart)
		return;
	
	if(g_iVoteCount == -1)
	{
		return;
	}
	new winner = PLAY_STANDARD;
	new id;//, team;
	new menu, newmenu;
	
	
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if(!is_user_connected(id))
			continue;
		//team = get_user_team(id);
		player_menu_info(id, menu, newmenu);
		
		if((menu == g_iFourthVote || menu == g_iTouchdownVote))
		{
			menu_cancel(id);	
			client_cmd( id, "menuselect 1" );
			//client_cmd( id, "slot1" );
		}
	}

	switch(voteid)
	{
		case VOTE_EXTRAPOINT:
		{
			winner = PLAY_FIELDGOAL;
			
			if(g_iTouchdownItems[1] > g_iTouchdownItems[0])
				winner = PLAY_STANDARD;
			
			switch(winner)
			{
				case PLAY_STANDARD: 	format( g_HudMsg3, 127, "Two Point Conversion." );
				case PLAY_FIELDGOAL:	format( g_HudMsg3, 127, "Field Goal." );
			}
		}
		case VOTE_FOURTHDOWN:
		{
			winner = PLAY_PUNT;
			
			new wincheck = -1;
			new i;
			new tie[3];
			new bool:isTie;
			
			for(i=0;i<3;i++)
			{
				if(g_iFourthItems[i] == 0)
					continue;
						
				if(wincheck != -1 && g_iFourthItems[i] == g_iFourthItems[wincheck] )
				{
					isTie = true;
					tie[i] = 1;
					tie[wincheck] = 1;
				}
					
				if(wincheck == -1)
					wincheck = i;
				else if(g_iFourthItems[i] > g_iFourthItems[wincheck] )
				{
					wincheck = i;
					tie[0] = 0; tie[1] = 0; tie[2] = 0;
					isTie = false;
				}
			}
			
			if( isTie )
			{
				new rand = random_num(1,2);
				winner = PLAY_PUNT;
				new rand2 = random_num(1,3);
				
				if(tie[0] == tie[1] && tie[0] == tie[2])
					winner = (rand2==1) ? PLAY_STANDARD : ((rand2==2) ? PLAY_PUNT : PLAY_FIELDGOAL);
				else if( tie[0] == tie[2] )
					winner = rand==1?PLAY_STANDARD:PLAY_FIELDGOAL;
				else if( tie[0] == tie[1] )
					winner = rand==1?PLAY_STANDARD:PLAY_PUNT;
				else if( tie[1] == tie[2] )
					winner = rand==1?PLAY_PUNT:PLAY_FIELDGOAL;
			}
			else
			{
				switch(wincheck)
				{
					case 0: winner = PLAY_STANDARD;
					case 1: winner = PLAY_PUNT;
					case 2: winner = PLAY_FIELDGOAL;	
				}	
			}
			
			switch(winner)
			{
				case PLAY_STANDARD: 	format( g_HudMsg3, 127, "Attempt 4th Down." );
				case PLAY_PUNT: 		format( g_HudMsg3, 127, "Punting." );
				case PLAY_FIELDGOAL:	format( g_HudMsg3, 127, "Field Goal." );
			}
		}	
	}

	g_iPlay = winner;
	set_task(RESTART_STATE_TIME, "BeginPlay", TASK_BEGINPLAY );	
	g_iVoteCount = -1;
}